var documenterSearchIndex = {"docs":
[{"location":"api/","page":"Internal API","title":"Internal API","text":"CollapsedDocStrings = true","category":"page"},{"location":"api/#MRIBuilder.jl-internal-API","page":"Internal API","title":"MRIBuilder.jl internal API","text":"","category":"section"},{"location":"api/","page":"Internal API","title":"Internal API","text":"MRIBuilder","category":"page"},{"location":"api/#MRIBuilder","page":"Internal API","title":"MRIBuilder","text":"Builds and optimises NMR/MRI sequences.\n\n\n\n\n\n","category":"module"},{"location":"api/#Type-diagram","page":"Internal API","title":"Type diagram","text":"","category":"section"},{"location":"api/","page":"Internal API","title":"Internal API","text":"import MRIBuilder.Variables: AbstractBlock\nimport InteractiveUtils: subtypes\nusing AbstractTrees\nimport Markdown\nAbstractTrees.children(x::Type) = subtypes(x)\nio = IOBuffer()\nprint_tree(io, AbstractBlock)\nseek(io, 0)\nMarkdown.parse(\"```\\n\" * read(io, String) * \"```\")","category":"page"},{"location":"api/#Sequence-components","page":"Internal API","title":"Sequence components","text":"","category":"section"},{"location":"api/","page":"Internal API","title":"Internal API","text":"Modules = [\n    MRIBuilder.Components,\n    MRIBuilder.Components.AbstractTypes,\n    MRIBuilder.Components.GradientWaveforms,\n    MRIBuilder.Components.GradientWaveforms.NoGradientBlocks,\n    MRIBuilder.Components.GradientWaveforms.ConstantGradientBlocks,\n    MRIBuilder.Components.GradientWaveforms.ChangingGradientBlocks,\n    MRIBuilder.Components.InstantGradients,\n    MRIBuilder.Components.Pulses,\n    MRIBuilder.Components.Pulses.GenericPulses,\n    MRIBuilder.Components.Pulses.InstantPulses,\n    MRIBuilder.Components.Pulses.ConstantPulses,\n    MRIBuilder.Components.Pulses.SincPulses,\n    MRIBuilder.Components.Pulses.CompositePulses,\n    MRIBuilder.Components.Readouts,\n    MRIBuilder.Components.Readouts.ADCs,\n    MRIBuilder.Components.Readouts.SingleReadouts,\n]","category":"page"},{"location":"api/#MRIBuilder.Components.AbstractTypes.BaseComponent","page":"Internal API","title":"MRIBuilder.Components.AbstractTypes.BaseComponent","text":"Super-type for all individual components that form an MRI sequence (i.e., RF pulse, gradient waveform, or readout event).\n\nRF pulses, instant gradients, and readouts are grouped together into EventComponent.\n\nThese all should have a variables.duration in addition to any other relevant variables.\n\n\n\n\n\n","category":"type"},{"location":"api/#MRIBuilder.Components.AbstractTypes.EventComponent","page":"Internal API","title":"MRIBuilder.Components.AbstractTypes.EventComponent","text":"Super-type for all RF pulses, instant gradients and readouts that might play out during a gradient waveform.\n\nThese all have an variables.effective_time, which should quantify at what single time one can approximate the RF pulse or readout to have taken place.\n\n\n\n\n\n","category":"type"},{"location":"api/#MRIBuilder.Components.AbstractTypes.GradientWaveform","page":"Internal API","title":"MRIBuilder.Components.AbstractTypes.GradientWaveform","text":"Super-type for all parts of a gradient waveform.\n\nN should be 1 for a 1D gradient waveform or 3 for a 3D one.\n\n\n\n\n\n","category":"type"},{"location":"api/#MRIBuilder.Components.AbstractTypes.RFPulseComponent","page":"Internal API","title":"MRIBuilder.Components.AbstractTypes.RFPulseComponent","text":"Super type for all RF pulses.\n\n\n\n\n\n","category":"type"},{"location":"api/#MRIBuilder.Components.AbstractTypes.ReadoutComponent","page":"Internal API","title":"MRIBuilder.Components.AbstractTypes.ReadoutComponent","text":"Super type for all readout events.\n\n\n\n\n\n","category":"type"},{"location":"api/#MRIBuilder.Components.AbstractTypes.edge_times-Tuple{MRIBuilder.Components.AbstractTypes.BaseComponent}","page":"Internal API","title":"MRIBuilder.Components.AbstractTypes.edge_times","text":"edge_times(container/component; tol=1e-6)\n\nReturns all the edge times during a sequence in ms.\n\nEdges are defined as any time, when:\n\nthe edge of a building block\nthe slope of the gradient profile changes suddenly\nan RF pulse starts or ends\n\nEdges that are within tol ms of each other are considered to be one edge (default: 1 ns).\n\n\n\n\n\n","category":"method"},{"location":"api/#MRIBuilder.Components.AbstractTypes.split_timestep-Tuple{Tuple{Number, MRIBuilder.Components.AbstractTypes.EventComponent}, Number}","page":"Internal API","title":"MRIBuilder.Components.AbstractTypes.split_timestep","text":"split_timestep(component, precision)\n\nIndicates the maximum timestep that a component can be linearised with and still achieve the required precision.\n\nTypically, this will be determined by the maximum second derivative:\n\nsqrtfrac2 epsilonmax(d^2ydx^2)\n\nIt should be infinite if the component is linear.\n\n\n\n\n\n","category":"method"},{"location":"api/#MRIBuilder.Variables.variables.amplitude","page":"Internal API","title":"MRIBuilder.Variables.variables.amplitude","text":"amplitude(pulse)\n\nReturn the amplitude of an RFPulseComponent in kHz.\n\n\n\n\n\n","category":"function"},{"location":"api/#MRIBuilder.Variables.variables.bandwidth","page":"Internal API","title":"MRIBuilder.Variables.variables.bandwidth","text":"bandwidth(pulse)\n\nReturn the bandwidth of an RFPulseComponent in kHz.\n\n\n\n\n\n","category":"function"},{"location":"api/#MRIBuilder.Variables.variables.flip_angle","page":"Internal API","title":"MRIBuilder.Variables.variables.flip_angle","text":"flip_angle(pulse)\n\nReturn the flip angle of an RFPulseComponent in degrees.\n\n\n\n\n\n","category":"function"},{"location":"api/#MRIBuilder.Variables.variables.frequency","page":"Internal API","title":"MRIBuilder.Variables.variables.frequency","text":"frequency(pulse)\n\nReturn the off-resonance frequency of an RFPulseComponent in kHz.\n\n\n\n\n\n","category":"function"},{"location":"api/#MRIBuilder.Variables.variables.gradient_strength","page":"Internal API","title":"MRIBuilder.Variables.variables.gradient_strength","text":"gradient_strength(gradient)\n\nMaximum 3D gradient strength of the gradient in kHz/um.\n\n\n\n\n\n","category":"function"},{"location":"api/#MRIBuilder.Variables.variables.phase","page":"Internal API","title":"MRIBuilder.Variables.variables.phase","text":"phase(pulse)\n\nReturn the phase of an RFPulseComponent in degrees.\n\n\n\n\n\n","category":"function"},{"location":"api/#MRIBuilder.Variables.variables.slew_rate","page":"Internal API","title":"MRIBuilder.Variables.variables.slew_rate","text":"slew_rate(gradient)\n\nMaximum 3D slew rate of the gradient in kHz/um/ms.\n\n\n\n\n\n","category":"function"},{"location":"api/#MRIBuilder.Components.GradientWaveforms","page":"Internal API","title":"MRIBuilder.Components.GradientWaveforms","text":"Module defining sub-types of the GradientWaveform.\n\nThere are only three types of [GradientBlock] objects:\n\nChangingGradient: any gradient changing linearly in strength.\nConstantGradient: any gradient staying constant in strength. These can overlap with a pulse (SliceSelectPulse).\nNoGradient: any part of the gradient waveform when no gradient is active.\n\nThese parts are combined into a full gradient waveform in a BuildingBlock.\n\nEach part of this gradient waveform can compute:\n\ngradient_strength: maximum gradient strength in each dimension.\nslew_rate: maximum slew rate in each dimension.\nqval/qvec: area under curve\nbmat_gradient: diffusion weighting (scalar in 1D or matrix in 3D).\n\n\n\n\n\n","category":"module"},{"location":"api/#MRIBuilder.Components.GradientWaveforms.NoGradientBlocks.NoGradient","page":"Internal API","title":"MRIBuilder.Components.GradientWaveforms.NoGradientBlocks.NoGradient","text":"NoGradient(duration)\n\nPart of a gradient waveform when there is no gradient active.\n\nUsually, you do not want to create this object directly, use a BuildingBlock instead.\n\n\n\n\n\n","category":"type"},{"location":"api/#MRIBuilder.Components.GradientWaveforms.ConstantGradientBlocks.ConstantGradient","page":"Internal API","title":"MRIBuilder.Components.GradientWaveforms.ConstantGradientBlocks.ConstantGradient","text":"ConstantGradient(gradient_strength_vector, duration, group=nothing)\nConstantGradient(gradient_strength_scalar, orientation, duration, group=nothing)\n\nUnderlying type for any flat part in a 3D (first constructor) or 3D (second constructor) gradient waveform.\n\nUsually, you do not want to create this object directly, use a BuildingBlock instead.\n\n\n\n\n\n","category":"type"},{"location":"api/#MRIBuilder.Components.GradientWaveforms.ChangingGradientBlocks.ChangingGradient","page":"Internal API","title":"MRIBuilder.Components.GradientWaveforms.ChangingGradientBlocks.ChangingGradient","text":"ChangingGradient(grad1_scalar, slew_rate_scalar, orientation, duration, group=nothing)\nChangingGradient(grad1_vec, slew_rate_vec, duration, group=nothing)\n\nUnderlying type for any linearly changing part in a 1D (first constructor) or 3D (second constructor) gradient waveform.\n\nUsually, you do not want to create this object directly, use a BuildingBlock instead.\n\n\n\n\n\n","category":"type"},{"location":"api/#MRIBuilder.Components.GradientWaveforms.ChangingGradientBlocks.split_gradient-Tuple{MRIBuilder.Components.GradientWaveforms.ChangingGradientBlocks.ChangingGradient, Vararg{Union{Number, JuMP.AbstractJuMPScalar}}}","page":"Internal API","title":"MRIBuilder.Components.GradientWaveforms.ChangingGradientBlocks.split_gradient","text":"split_gradient(constant/changing_gradient_block, times...)\n\nSplit a single gradient at a given times.\n\nAll times are relative to the start of the gradient block (in ms). Times are assumed to be in increasing order and between 0 and the duration of the gradient block.\n\nFor N times this returns a vector with the N+1 replacement ConstantGradient or ChangingGradient objects.\n\n\n\n\n\n","category":"method"},{"location":"api/#MRIBuilder.Components.InstantGradients.InstantGradient","page":"Internal API","title":"MRIBuilder.Components.InstantGradients.InstantGradient","text":"InstantGradient(; orientation=nothing, group=nothing, variables...)\n\nIf the orientation is set an InstantGradient1D is returned, otherwise an InstantGradient3D.\n\nParameters\n\norientation sets the gradient orientation as a length-3 vector. If not set, the gradient can be in any direction.\ngroup: name of the group to which this gradient belongs (used for scaling and rotating).\n\nVariables\n\nvariables.qvec: Spatial frequency on which spins will be dephased due to this pulsed gradient in rad/um.\nvariables.spoiler: Length-scale on which spins will be dephased by exactly 2π in mm.\n\n\n\n\n\n","category":"type"},{"location":"api/#MRIBuilder.Components.InstantGradients.InstantGradient1D","page":"Internal API","title":"MRIBuilder.Components.InstantGradients.InstantGradient1D","text":"An InstantGradient with a fixed orientation.\n\n\n\n\n\n","category":"type"},{"location":"api/#MRIBuilder.Components.InstantGradients.InstantGradient3D","page":"Internal API","title":"MRIBuilder.Components.InstantGradients.InstantGradient3D","text":"An InstantGradient with a variable orientation.\n\n\n\n\n\n","category":"type"},{"location":"api/#MRIBuilder.Components.Pulses.GenericPulses.GenericPulse","page":"Internal API","title":"MRIBuilder.Components.Pulses.GenericPulses.GenericPulse","text":"GenericPulse(time, amplitude, phase, effective_time=<halfway>)\nGenericPulse(time, amplitude; phase=0., frequency=0., effective_time=<halfway>)\n\nCreate a Pulse profile that has been fully defined by N control point.\n\nAll arguments should be arrays of the same length N defining these control points.\n\nThis pulse has no free variables.\n\ntime: time since the start of this BuildingBlock in ms.\namplitude: amplitude of the RF pulse at every timepoint in kHz.\nphase: phase of the RF pulse at every timpoint in degrees. If not set explicitly it will be determined by the provided starting phase (degrees) and the frequency (kHz).\neffective_time: the time that the RF pulse should be considered to have taken place when computing a Pathway (defaults: whenever half of the final flip angle has been achieved for on-resonance spins).\n\n\n\n\n\n","category":"type"},{"location":"api/#MRIBuilder.Components.Pulses.GenericPulses.GenericPulse-Tuple{GenericPulse, Number, Number}","page":"Internal API","title":"MRIBuilder.Components.Pulses.GenericPulses.GenericPulse","text":"GenericPulse(pulse, t1, t2)\n\nCreates a new GenericPulse by slicing another pulse between t1 and t2\n\n\n\n\n\n","category":"method"},{"location":"api/#MRIBuilder.Components.Pulses.InstantPulses.InstantPulse","page":"Internal API","title":"MRIBuilder.Components.Pulses.InstantPulses.InstantPulse","text":"InstantPulse(; flip_angle=nothing, phase=nothing, group=nothing)\n\nReturn an instant RF pulse that rotates all spins by flip_angle around an axis that has an angle of phase with the X-Y plane.\n\nParameters\n\ngroup: name of the group to which this pulse belongs. This is used for scaling or adding phases/off-resonance frequencies.\n\nVariables\n\nvariables.flip_angle: angle by which spins are rotated in degrees.\nvariables.phase: angle of axis around which spins are rotated in degrees.\n\n\n\n\n\n","category":"type"},{"location":"api/#MRIBuilder.Components.Pulses.ConstantPulses.ConstantPulse","page":"Internal API","title":"MRIBuilder.Components.Pulses.ConstantPulses.ConstantPulse","text":"ConstantPulse(; variables...)\n\nRepresents an radio-frequency pulse with a constant amplitude and frequency (i.e., a rectangular function).\n\nParameters\n\ngroup: name of the group to which this pulse belongs. This is used for scaling or adding phases/off-resonance frequencies.\n\nVariables\n\nvariables.flip_angle: rotation expected for on-resonance spins in degrees.\nvariables.duration: duration of the RF pulse in ms.\nvariables.amplitude: amplitude of the RF pulse in kHz.\nvariables.phase: phase at the start of the RF pulse in degrees.\nvariables.frequency: frequency of the RF pulse relative to the Larmor frequency (in kHz).\n\n\n\n\n\n","category":"type"},{"location":"api/#MRIBuilder.Components.Pulses.SincPulses.SincPulse","page":"Internal API","title":"MRIBuilder.Components.Pulses.SincPulses.SincPulse","text":"SincPulse(; Nzeros=3, apodise=true, variables...)\n\nRepresents a radio-frequency pulse with a sinc-like amplitude and constant frequency.\n\nParameters\n\nNzeros: Number of zero-crossings on each side of the sinc pulse. Can be set to a tuple with two values to have a different number of zero crossings on the left and the right of the sinc pulse.\napodise: if true (default) applies a Hanning apodising window to the sinc pulse.\ngroup: name of the group to which this pulse belongs. This is used for scaling or adding phases/off-resonance frequencies.\n\nVariables\n\nvariables.flip_angle: rotation expected for on-resonance spins in degrees.\nvariables.duration: duration of the RF pulse in ms.\nvariables.amplitude: amplitude of the RF pulse in kHz.\nvariables.phase: phase at the start of the RF pulse in degrees.\nvariables.frequency: frequency of the RF pulse relative to the Larmor frequency (in kHz).\nvariables.bandwidth: width of the rectangular function in frequency space (in kHz). If the duration is short (compared with 1/bandwidth), this bandwidth will only be approximate.\n\n\n\n\n\n","category":"type"},{"location":"api/#MRIBuilder.Variables.variables.N_left","page":"Internal API","title":"MRIBuilder.Variables.variables.N_left","text":"N_left(sinc_pulse)\n\nNumber of zero-crossings of the SincPulse before the maximum.\n\nAlso, see variables.N_right\n\n\n\n\n\n","category":"function"},{"location":"api/#MRIBuilder.Variables.variables.N_right","page":"Internal API","title":"MRIBuilder.Variables.variables.N_right","text":"N_left(sinc_pulse)\n\nNumber of zero-crossings of the SincPulse after the maximum.\n\nAlso, see variables.N_left\n\n\n\n\n\n","category":"function"},{"location":"api/#MRIBuilder.Variables.variables.lobe_duration","page":"Internal API","title":"MRIBuilder.Variables.variables.lobe_duration","text":"lobe_duration(sinc_pulse)\n\nTime between two zero-crossings of a SincPulse.\n\n\n\n\n\n","category":"function"},{"location":"api/#MRIBuilder.Components.Pulses.CompositePulses.CompositePulse","page":"Internal API","title":"MRIBuilder.Components.Pulses.CompositePulses.CompositePulse","text":"CompositePulse(; base_pulse, nweights, variables...)\n\nA composite RF pulse formed by repeating a base RF pulse.\n\nParameters\n\nbase_pulse: The base RF pulse that will be repeated.\nnweights: The number of repeated pulses. This will be ignored if a vector of weights is explicitly provided.\n\nVariables\n\nweights: The weight of each of the base RF pulses.\ninterpulse_delay: Time between the center of the RF pulses. If not otherwise constrained, it will be minimised.\nscale_amplitude: How strongly one should scale the amplitude versus the duration to achieve the desired weights. If set to 1 only the RF pulse amplitude will be scaled. If set to 0 only the RF pulse duration will be scaled.\n\n\n\n\n\n","category":"type"},{"location":"api/#MRIBuilder.Components.Pulses.CompositePulses.BinomialPulse-Tuple{}","page":"Internal API","title":"MRIBuilder.Components.Pulses.CompositePulses.BinomialPulse","text":"BinomialPulse(; base_pulse, npulses, flip=true, variables...)\n\nCreates a CompositePulse of npulses repeats of base_pulse, where the weights are set by the biomial distribution.\n\nIf flip is true (default) every other pulse will be flipped (so that the total excitation is canceled). The variables are defined in CompositePulse.\n\n\n\n\n\n","category":"method"},{"location":"api/#MRIBuilder.Components.Readouts.ADCs.ADC","page":"Internal API","title":"MRIBuilder.Components.Readouts.ADCs.ADC","text":"ADC(; center_halfway=true, oversample=1, variables...)\n\nAdds a readout event.\n\nParameters\n\ncenter_halfway: by default the time_to_center is assumed to be half of the duration. Set this to false to disable this assumption.\noversample: by how much the ADC should oversample (minimum of 1).\n\nVariables\n\nresolution: number of voxels in the readout direction. This can be a non-integer value during optimisation.\nnsamples: number of samples in the readout. This can be a non-integer value during optimisation.\ndwell_time: Time between each readout sample in ms.\nduration: Total duration of the ADC event in ms.\ntime_to_center: time till the center of k-space from start of ADC in ms.\neffective_time: same as time_to_center.\n\n\n\n\n\n","category":"type"},{"location":"api/#MRIBuilder.Variables.variables.dwell_time","page":"Internal API","title":"MRIBuilder.Variables.variables.dwell_time","text":"dwell_time(adc)\n\nThe dwell time of the ADC readout in ms.\n\n\n\n\n\n","category":"function"},{"location":"api/#MRIBuilder.Variables.variables.nsamples","page":"Internal API","title":"MRIBuilder.Variables.variables.nsamples","text":"nsamples(adc)\n\nNumber of samples in an ADC.\n\n\n\n\n\n","category":"function"},{"location":"api/#MRIBuilder.Variables.variables.oversample","page":"Internal API","title":"MRIBuilder.Variables.variables.oversample","text":"oversample(adc)\n\nThe oversampling rate of the ADC readout.\n\n\n\n\n\n","category":"function"},{"location":"api/#MRIBuilder.Variables.variables.resolution","page":"Internal API","title":"MRIBuilder.Variables.variables.resolution","text":"resolution(readout)\n\nResolution of the readout.\n\n\n\n\n\n","category":"function"},{"location":"api/#MRIBuilder.Variables.variables.time_to_center","page":"Internal API","title":"MRIBuilder.Variables.variables.time_to_center","text":"time_to_center(adc)\n\nThe time of the ADC readout to reach the center of k-space.\n\n\n\n\n\n","category":"function"},{"location":"api/#MRIBuilder.Components.Readouts.SingleReadouts.SingleReadout","page":"Internal API","title":"MRIBuilder.Components.Readouts.SingleReadouts.SingleReadout","text":"SingleReadout()\n\nRepresents an instantaneous Readout of the signal.\n\nIt has no parameters or variables to set.\n\n\n\n\n\n","category":"type"},{"location":"api/#Containers-for-sequence-components","page":"Internal API","title":"Containers for sequence components","text":"","category":"section"},{"location":"api/","page":"Internal API","title":"Internal API","text":"Modules = [\n    MRIBuilder.Containers,\n    MRIBuilder.Containers.Abstract,\n    MRIBuilder.Containers.BuildingBlocks,\n    MRIBuilder.Containers.BaseSequences,\n    MRIBuilder.Containers.Alternatives,\n]","category":"page"},{"location":"api/#MRIBuilder.Containers.Abstract.ContainerBlock","page":"Internal API","title":"MRIBuilder.Containers.Abstract.ContainerBlock","text":"Parent type for BuildingBlock or BaseSequence, i.e., any building block that contains other MRI components/blocks.\n\nIterate over them to get the individual components.\n\n\n\n\n\n","category":"type"},{"location":"api/#MRIBuilder.Containers.Abstract.amplitude","page":"Internal API","title":"MRIBuilder.Containers.Abstract.amplitude","text":"amplitude(sequence, time)\n\nReturns the RF amplitude at a particular time within the sequence in kHz.\n\n\n\n\n\n","category":"function"},{"location":"api/#MRIBuilder.Containers.Abstract.end_time-Tuple{ContainerBlock, Any, Vararg{Any}}","page":"Internal API","title":"MRIBuilder.Containers.Abstract.end_time","text":"end_time(container, indices...)\n\nReturns the start time of component with given indices with respect to the start of the ContainerBlock.\n\nAlso see variables.duration, start_time, and variables.effective_time\n\n\n\n\n\n","category":"method"},{"location":"api/#MRIBuilder.Containers.Abstract.frequency","page":"Internal API","title":"MRIBuilder.Containers.Abstract.frequency","text":"frequency(sequence, time)\n\nReturns the RF frequency at a particular time within the sequence in kHz.\n\nNaN is returned if there is no pulse activate at that time.\n\n\n\n\n\n","category":"function"},{"location":"api/#MRIBuilder.Containers.Abstract.gradient_strength","page":"Internal API","title":"MRIBuilder.Containers.Abstract.gradient_strength","text":"gradient_strength(sequence, time)\n\nReturns the gradient strength at a particular time within the sequence.\n\n\n\n\n\n","category":"function"},{"location":"api/#MRIBuilder.Containers.Abstract.iter-Tuple{ContainerBlock, Val}","page":"Internal API","title":"MRIBuilder.Containers.Abstract.iter","text":"iter(sequence, get_type)\n\nHelper functions for any iter_* functions.\n\n\n\n\n\n","category":"method"},{"location":"api/#MRIBuilder.Containers.Abstract.iter_blocks-Tuple{ContainerBlock}","page":"Internal API","title":"MRIBuilder.Containers.Abstract.iter_blocks","text":"iter_blocks(sequence)\n\nReturns all the building blocks in the sequence with the time they will start\n\n\n\n\n\n","category":"method"},{"location":"api/#MRIBuilder.Containers.Abstract.iter_instant_gradients-Tuple{ContainerBlock}","page":"Internal API","title":"MRIBuilder.Containers.Abstract.iter_instant_gradients","text":"iter_instant_gradients(sequence)\n\nReturns all the InstantGradient within the sequence with their timings\n\n\n\n\n\n","category":"method"},{"location":"api/#MRIBuilder.Containers.Abstract.iter_instant_pulses-Tuple{ContainerBlock}","page":"Internal API","title":"MRIBuilder.Containers.Abstract.iter_instant_pulses","text":"iter_instant_pulses(sequence)\n\nReturns all the InstantPulse within the sequence with their timings\n\n\n\n\n\n","category":"method"},{"location":"api/#MRIBuilder.Containers.Abstract.phase","page":"Internal API","title":"MRIBuilder.Containers.Abstract.phase","text":"phase(sequence, time)\n\nReturns the RF phase at a particular time within the sequence in degrees.\n\nNaN is returned if there is no pulse activate at that time.\n\n\n\n\n\n","category":"function"},{"location":"api/#MRIBuilder.Containers.Abstract.start_time-Tuple{ContainerBlock, Any, Any, Vararg{Any}}","page":"Internal API","title":"MRIBuilder.Containers.Abstract.start_time","text":"start_time(container, indices...)\n\nReturns the start time of component with given indices with respect to the start of the ContainerBlock.\n\nAlso see variables.duration, end_time, and variables.effective_time\n\n\n\n\n\n","category":"method"},{"location":"api/#MRIBuilder.Variables.get_gradient","page":"Internal API","title":"MRIBuilder.Variables.get_gradient","text":"get_gradient(container, time)\n\nGets the gradient running at a particular time (in ms) during a sequence of building block.\n\nThis function will return a tuple with 2 elements:\n\nThe GradientWaveform itself (which could be a NoGradient object).\nThe time since the start of the gradient\n\n\n\n\n\n","category":"function"},{"location":"api/#MRIBuilder.Variables.get_pulse","page":"Internal API","title":"MRIBuilder.Variables.get_pulse","text":"get_pulse(container, time)\n\nGets the pulse running at a particular time (in ms) during a sequence of building block.\n\nIf there is a RF pulse, this function will return a tuple with 2 elements:\n\nThe RFPulseComponent itself\nThe time since the start of the pulse\n\nIf there is no active RF pulse, nothing is returned.\n\n\n\n\n\n","category":"function"},{"location":"api/#MRIBuilder.Variables.variables.effective_time","page":"Internal API","title":"MRIBuilder.Variables.variables.effective_time","text":"effective_time(container, indices...)\n\nReturns the start time of component with given indices with respect to the start of the ContainerBlock.\n\nThis will crash if the component does not have an variables.effective_time (e.g., if it is (part of) a gradient waveform).\n\nAlso see variables.duration, start_time, and end_time\n\n\n\n\n\n","category":"function"},{"location":"api/#MRIBuilder.Variables.variables.readout_times","page":"Internal API","title":"MRIBuilder.Variables.variables.readout_times","text":"readout_times(sequence)\n\nReturns all the times that the sequence will readout.\n\n\n\n\n\n","category":"function"},{"location":"api/#MRIBuilder.Containers.BuildingBlocks","page":"Internal API","title":"MRIBuilder.Containers.BuildingBlocks","text":"Defines BaseBuildingBlock, BuildingBlock and Wait.\n\n\n\n\n\n","category":"module"},{"location":"api/#MRIBuilder.Containers.BuildingBlocks.BaseBuildingBlock","page":"Internal API","title":"MRIBuilder.Containers.BuildingBlocks.BaseBuildingBlock","text":"Basic BuildingBlock, which can consist of a gradient waveforms with any number of RF pulses/readouts overlaid\n\nMain interface:\n\niteration will give the gradient waveforms interspersed by RF pulses/readouts.\nIndiviual indices can be accessed using keys(building_block)\nwaveform_sequence returns just the gradient waveform as a sequence of GradientWaveform objects.\nwaveform returns just the gradient waveform as a sequence of (time, gradient_strength) tuples.\nevents returns the RF pulses and readouts.\nvariables.qvec returns area under curve for (part of) the gradient waveform.\n\nSub-types need to implement:\n\nBase.keys: returns sequence of keys to all the components.\nBase.getindex: returns the actual component for each key. For events (readout/pulses) this should return a tuple with (time delay till start, event).\n\n\n\n\n\n","category":"type"},{"location":"api/#MRIBuilder.Containers.BuildingBlocks.BuildingBlock","page":"Internal API","title":"MRIBuilder.Containers.BuildingBlocks.BuildingBlock","text":"BuildingBlock(waveform, events; duration=nothing, orientation=nothing, group)\n\nGeneric BaseBuildingBlock that can capture any overlapping gradients, RF pulses, and/or readouts. The gradients cannot contain any free variables.\n\nScanner constraints are automatically applied.\n\nArguments\n\nwaveform: Sequence of 2-element tuples with (time, (Gx, Gy, Gz)). If orientation is set then the tuple is expected to look like (time, G). This cannot contain any free variables.\nevents: Sequence of 2-element tuples with (time, pulse/readout). The time is the start time of the pulse/readout.\nduration: duration of this BuildingBlock. If not set then it will be assumed to be the time of the last element in waveform.\norientation: orientation of the gradients in the waveform. If not set, then the full gradient vector should be given explicitly.\ngroup: group of the gradient waveform\n\n\n\n\n\n","category":"type"},{"location":"api/#MRIBuilder.Containers.BuildingBlocks.BuildingBlock-Tuple{MRIBuilder.Components.AbstractTypes.EventComponent}","page":"Internal API","title":"MRIBuilder.Containers.BuildingBlocks.BuildingBlock","text":"BuildingBlock(pulse/readout)\n\nCreates a BuildingBlock with no gradients and just the single [EventComponent]@(ref).\n\n\n\n\n\n","category":"method"},{"location":"api/#MRIBuilder.Containers.BuildingBlocks.Wait","page":"Internal API","title":"MRIBuilder.Containers.BuildingBlocks.Wait","text":"An empty BuildingBlock representing dead time.\n\nIt only has a single variable, namely its variables.duration.\n\n\n\n\n\n","category":"type"},{"location":"api/#MRIBuilder.Containers.BuildingBlocks.events-Tuple{BaseBuildingBlock}","page":"Internal API","title":"MRIBuilder.Containers.BuildingBlocks.events","text":"events(building_block)\n\nReturns just the non-gradient (i.e., RF pulses/readouts) events as a sequence of EventComponent objects (with their keys).\n\n\n\n\n\n","category":"method"},{"location":"api/#MRIBuilder.Containers.BuildingBlocks.waveform-Tuple{BaseBuildingBlock}","page":"Internal API","title":"MRIBuilder.Containers.BuildingBlocks.waveform","text":"waveform(building_block)\n\nReturns the gradient waveform of any BaseBuildingBlock as a sequence of control points.\n\nEach control point is stored as a tuple with the time in ms and the gradient as a length-3 vector. The gradient is linearly interpolated between these points (see waveform_sequence).\n\n\n\n\n\n","category":"method"},{"location":"api/#MRIBuilder.Containers.BuildingBlocks.waveform_sequence-Tuple{BaseBuildingBlock, Any, Any}","page":"Internal API","title":"MRIBuilder.Containers.BuildingBlocks.waveform_sequence","text":"waveform_sequence(building_block, first, last)\n\nGets the sequence of GradientWaveform from the event with key first till the event with key last.\n\nSetting first to nothing indicates to start from the beginning of the building_block. Similarly, setting last to nothing indicates to continue till the end of the building_block.\n\n\n\n\n\n","category":"method"},{"location":"api/#MRIBuilder.Containers.BuildingBlocks.waveform_sequence-Tuple{BaseBuildingBlock}","page":"Internal API","title":"MRIBuilder.Containers.BuildingBlocks.waveform_sequence","text":"waveform_sequence(building_block)\n\nReturns just the gradient waveform as a sequence of GradientWaveform objects (with their keys).\n\n\n\n\n\n","category":"method"},{"location":"api/#MRIBuilder.Variables.variables.bmat_gradient","page":"Internal API","title":"MRIBuilder.Variables.variables.bmat_gradient","text":"bmat_gradient(overlapping, qstart[, first_event, last_event])\n\nComputes the addition to the variables.bmat contributed by a specific building block or gradient.\n\nqstart represents the variables.qvec at the start of this component.\n\nIf first_event is set to something else than nothing, only the gradient waveform after this RF pulse/Readout will be considered. Similarly, if last_event is set to something else than nothing, only the gradient waveform up to this RF pulse/Readout will be considered.\n\n\n\n\n\n","category":"function"},{"location":"api/#MRIBuilder.Variables.variables.qvec","page":"Internal API","title":"MRIBuilder.Variables.variables.qvec","text":"qvec(overlapping[, first_event, last_event])\n\nComputes the area under the curve for the gradient waveform in BaseBuildingBlock.\n\nIf first_event is set to something else than nothing, only the gradient waveform after this RF pulse/Readout will be considered. Similarly, if last_event is set to something else than nothing, only the gradient waveform up to this RF pulse/Readout will be considered.\n\n\n\n\n\n","category":"function"},{"location":"api/#MRIBuilder.Containers.BaseSequences","page":"Internal API","title":"MRIBuilder.Containers.BaseSequences","text":"Defines BaseSequence and Sequence\n\n\n\n\n\n","category":"module"},{"location":"api/#MRIBuilder.Containers.BaseSequences.BaseSequence","page":"Internal API","title":"MRIBuilder.Containers.BaseSequences.BaseSequence","text":"Super-type of any sequence of non-overlapping building blocks that should be played after each other.\n\nIt contains N ContainerBlock objects (e.g., building blocks or other sequences).\n\nMain interface:\n\nActs as an iterable containing the blocks and sequences.\nIndiviual blocks/sequences can be obtained using indexing.\nIf there is a finite number of repeats, the iteration will continue over all repeats.\n\nSub-types need to implement:\n\nget_index_single_TR: return the index assuming it is between 1 and N\n\n\n\n\n\n","category":"type"},{"location":"api/#MRIBuilder.Containers.BaseSequences.Sequence","page":"Internal API","title":"MRIBuilder.Containers.BaseSequences.Sequence","text":"Sequence(blocks; name=:Sequence, variables...)\nSequence(blocks...; name=:Sequence, variables...)\n\nDefines an MRI sequence from a vector of building blocks.\n\nArguments\n\nblocks: The actual building blocks that will be played in sequence. All the building blocks must be of type ContainerBlock, which means that they cannot only contain actual BaseBuildingBlock objects, but also other BaseSequence objects.   Objects of a different type are converted into a ContainerBlock internally:\nnumbers/nothing/:min/:max : replaced with a Wait block with the appropriate constraint/objective added to its variables.duration.\nRF pulse or readout: will be embedded within a BuildingBlock of the appropriate length\n\nSpecific named sequences might define additional variables.\n\n\n\n\n\n","category":"type"},{"location":"api/#MRIBuilder.Containers.BaseSequences.get_index_single_TR-Tuple{BaseSequence, Integer}","page":"Internal API","title":"MRIBuilder.Containers.BaseSequences.get_index_single_TR","text":"get_index_single_TR(sequence, index)\n\nUsed internally by any BaseSequence to get a specific block. The index should be between 1 and N. It should be implemented for any sub-classes of BaseSequence.\n\n\n\n\n\n","category":"method"},{"location":"api/#MRIBuilder.Containers.BaseSequences.nrepeat-Tuple{BaseSequence}","page":"Internal API","title":"MRIBuilder.Containers.BaseSequences.nrepeat","text":"nrepeat(sequence)\n\nHow often sequence should be repeated. \n\n\n\n\n\n","category":"method"},{"location":"api/#MRIBuilder.Containers.BaseSequences.to_block-Tuple{ContainerBlock}","page":"Internal API","title":"MRIBuilder.Containers.BaseSequences.to_block","text":"to_block(block_like)\n\nConverst object into something that can be included in the sequence:\n\n:min/:max/number/variable/nothing => Wait.\nbuilding_block or sequence => no change.\nRF pulse/readout => will be embedded within a BuildingBlock.\n\n\n\n\n\n","category":"method"},{"location":"api/#MRIBuilder.Containers.Alternatives.AbstractAlternativeBlocks","page":"Internal API","title":"MRIBuilder.Containers.Alternatives.AbstractAlternativeBlocks","text":"Parent type for all blocks that can take different MR sequence components between multiple repetitions of the sequence.\n\nThey can be extended into their individual components using adjust(<name>=:all).\n\nEach subtype of AbstractAlternativeBlock needs to implement two methods:\n\nget_alternatives_name: returns the name used to identify this block in adjust\nget_alternatives_options: returns a dictionary mapping the name of the different options to a ContainerBlock with the actual sequence building block.\n\n\n\n\n\n","category":"type"},{"location":"api/#MRIBuilder.Containers.Alternatives.AlternativeBlocks","page":"Internal API","title":"MRIBuilder.Containers.Alternatives.AlternativeBlocks","text":"AlternativeBlocks(name, blocks)\n\nRepresents a part of the sequence where there are multiple possible alternatives.\n\nVariables can be matched across these alternatives using match_blocks!.\n\nThe name is a symbol that is used to identify this AlternativeBlocks in the broader sequence (as in adjust).\n\n\n\n\n\n","category":"type"},{"location":"api/#MRIBuilder.Containers.Alternatives.get_alternatives_name-Tuple{AlternativeBlocks}","page":"Internal API","title":"MRIBuilder.Containers.Alternatives.get_alternatives_name","text":"get_alternatives_name(alternative_block)\n\nGet the name with which any AbstractAlternativeBlocks will be identified in a call to adjust.\n\n\n\n\n\n","category":"method"},{"location":"api/#MRIBuilder.Containers.Alternatives.get_alternatives_options-Tuple{AlternativeBlocks}","page":"Internal API","title":"MRIBuilder.Containers.Alternatives.get_alternatives_options","text":"get_alternatives_options(alternative_block)\n\nGet the options available for a AbstractAlternativeBlocks.\n\n\n\n\n\n","category":"method"},{"location":"api/#MRIBuilder.Containers.Alternatives.match_blocks!-Tuple{AbstractAlternativeBlocks, Any}","page":"Internal API","title":"MRIBuilder.Containers.Alternatives.match_blocks!","text":"match_blocks!(alternatives, function)\n\nMatches the outcome of given function on each of the building blocks in AlternativeBlocks.\n\nFor example, match_blocks!(alternatives, duration) will ensure that all the alternative building blocks have the same duration.\n\n\n\n\n\n","category":"method"},{"location":"api/#Pre-defined-sequence-parts","page":"Internal API","title":"Pre-defined sequence parts","text":"","category":"section"},{"location":"api/","page":"Internal API","title":"Internal API","text":"There are helper functions available to actually add these to a sequence.","category":"page"},{"location":"api/","page":"Internal API","title":"Internal API","text":"Modules = [\n    MRIBuilder.Parts,\n    MRIBuilder.Parts.Trapezoids,\n    MRIBuilder.Parts.SpoiltSliceSelects,\n    MRIBuilder.Parts.SliceSelectRephases,\n    MRIBuilder.Parts.EPIReadouts,\n]","category":"page"},{"location":"api/#MRIBuilder.Parts.Trapezoids","page":"Internal API","title":"MRIBuilder.Parts.Trapezoids","text":"Defines a set of different options for MRI gradients.\n\n\n\n\n\n","category":"module"},{"location":"api/#MRIBuilder.Parts.Trapezoids.BaseTrapezoid","page":"Internal API","title":"MRIBuilder.Parts.Trapezoids.BaseTrapezoid","text":"Parent type for any BuildingBlock that has a trapezoidal gradient waveform.\n\nSub-types:\n\nTrapezoid\nSliceSelect\nLineReadout\n\nThe N indicates whether the gradient has a fixed orientation (N=1) or is free (N=3).\n\n\n\n\n\n","category":"type"},{"location":"api/#MRIBuilder.Parts.Trapezoids.LineReadout","page":"Internal API","title":"MRIBuilder.Parts.Trapezoids.LineReadout","text":"LineReadout(adc; ramp_overlap=1., orientation=nothing, group=nothing, variables...)\n\nDefines a trapezoidal gradient with an ADC readout overlaid.\n\nParameters and variables are identical as for Trapezoid with the addition of:\n\nParameters\n\nadc: ADC object that describes the readout.\nramp_overlap: how much the gradient ramp should overlap with the ADC. 0 for no overlap, 1 for full overlap (default: 1). Can be set to nothing to become a free variable.\n\nVariables\n\nvariables.fov: FOV of the output image along this single k-space line in mm.\nvariables.voxel_size: size of each voxel along this single k-space line in mm.\n\n\n\n\n\n","category":"type"},{"location":"api/#MRIBuilder.Parts.Trapezoids.SliceSelect","page":"Internal API","title":"MRIBuilder.Parts.Trapezoids.SliceSelect","text":"SliceSelect(pulse; orientation=nothing, group=nothing, variables...)\n\nDefines a trapezoidal gradient with a pulse played out during the flat time.\n\nParameters and variables are identical as for Trapezoid with the addition of:\n\nParameters\n\npulse: sub-type of RFPulseComponent that describes the RF pulse.\n\nVariables\n\nslice_thickness: thickness of the selected slice in mm\n\n\n\n\n\n","category":"type"},{"location":"api/#MRIBuilder.Parts.Trapezoids.Trapezoid","page":"Internal API","title":"MRIBuilder.Parts.Trapezoids.Trapezoid","text":"Trapezoid(; orientation=nothing, group=nothing, variables...)\n\nDefines a trapezoidal pulsed gradient\n\nParameters\n\norientation sets the gradient orientation (completely free by default). Can be set to a vector for a fixed orientation.\ngroup: assign the trapezoidal gradient to a specific group. This group will be used to scale or rotate the gradients after optimisation.\n\nVariables\n\nVariables can be set during construction or afterwards as an attribute. If not set, they will be determined during the sequence optimisation.\n\nTiming variables\n\nvariables.rise_time: Time of the gradient to reach from 0 to maximum in ms. If explicitly set to 0, the scanner slew rate will be ignored.\nvariables.flat_time: Time that the gradient stays at maximum strength in ms.\nvariables.δ: effective pulse duration (rise_time + flat_time) in ms.\nvariables.duration: total pulse duration (2 * rise_time + flat_time) in ms.\n\nGradient variables\n\nvariables.gradient_strength: Maximum gradient strength achieved during the pulse in kHz/um\nvariables.qvec: Spatial scale on which spins will be dephased due to this pulsed gradient in rad/um (given by δ * gradient_strength).\n\nThe bvalue can be constrained for multiple gradient pulses by creating a Pathway.\n\n\n\n\n\n","category":"type"},{"location":"api/#MRIBuilder.Parts.Trapezoids.opposite_kspace_lines-Tuple{}","page":"Internal API","title":"MRIBuilder.Parts.Trapezoids.opposite_kspace_lines","text":"opposite_kspace_lines(; orientation=[1, 0, 0], kwargs...)\n\nReturn a positive and negative readout of a k-space line.\n\n\n\n\n\n","category":"method"},{"location":"api/#MRIBuilder.Variables.variables.flat_time","page":"Internal API","title":"MRIBuilder.Variables.variables.flat_time","text":"flat_time(trapezoid)\n\nReturns the flat time of a Trapezoid gradient profile in ms.\n\n\n\n\n\n","category":"function"},{"location":"api/#MRIBuilder.Variables.variables.fov","page":"Internal API","title":"MRIBuilder.Variables.variables.fov","text":"fov(readout)\n\nDefines the field of view of a readout in mm.\n\n\n\n\n\n","category":"function"},{"location":"api/#MRIBuilder.Variables.variables.ramp_overlap","page":"Internal API","title":"MRIBuilder.Variables.variables.ramp_overlap","text":"ramp_overlap(line_readout)\n\nReturn the fraction of the gradient ramp that overlaps with the ADC readout.\n\nSet to 0 to ensure that the ADC is only active during the flat time of the readout.\n\n\n\n\n\n","category":"function"},{"location":"api/#MRIBuilder.Variables.variables.rise_time","page":"Internal API","title":"MRIBuilder.Variables.variables.rise_time","text":"rise_time(trapezoid)\n\nReturns the rise time of a Trapezoid gradient profile in ms.\n\n\n\n\n\n","category":"function"},{"location":"api/#MRIBuilder.Variables.variables.slice_thickness","page":"Internal API","title":"MRIBuilder.Variables.variables.slice_thickness","text":"slice_thickness(slice_select)\n\nDefines the slice thickness for a RF pulse with an active gradient in mm (e.g., SliceSelect).\n\nDefines as variables.gradient_strength_norm(gradient) / variables.bandwidth(pulse)\n\n\n\n\n\n","category":"function"},{"location":"api/#MRIBuilder.Variables.variables.voxel_size","page":"Internal API","title":"MRIBuilder.Variables.variables.voxel_size","text":"voxel_size(readout)\n\nDefines the voxel size of a readout in mm.\n\n\n\n\n\n","category":"function"},{"location":"api/#MRIBuilder.Variables.variables.δ","page":"Internal API","title":"MRIBuilder.Variables.variables.δ","text":"δ(trapezoid)\n\nReturns the effective duration of a Trapezoid gradient profile in ms.\n\nDefined as variables.rise_time + variables.flat_time.\n\n\n\n\n\n","category":"function"},{"location":"api/#MRIBuilder.Parts.SpoiltSliceSelects.SpoiltSliceSelect","page":"Internal API","title":"MRIBuilder.Parts.SpoiltSliceSelects.SpoiltSliceSelect","text":"SpoiltSliceSelect(pulse; parameters..., variables...)\n\nAdds slice selection to the pulse and surrounds it with spoiler gradients.\n\nParameters\n\norientation: vector with orientation of the slice selection and the spoilers (default: [0, 0, 1])\ngroup: name of the group of the gradient. This will be used to scale and rotate the gradients after optimisation. Scaling is not recommended as this might ruin the spoiling.\n\nVariables\n\nduration: total duration of the block in ms.\nslice_thickness: slice thickness in mm.\nspoiler: length scale on which the spoilers achieve 2π dephasing in mm. This sets the minimum spoiling. If this spoiling level is not achieved by the slice-select gradient alone, then there will be additional gradients added.\n\n\n\n\n\n","category":"type"},{"location":"api/#MRIBuilder.Variables.variables.all_gradient_strengths","page":"Internal API","title":"MRIBuilder.Variables.variables.all_gradient_strengths","text":"all_gradient_strengths(spoilt_slice_select)\n\nReturns the gradient strength before, during, and after the pulse in SpoiltSliceSelect.\n\n\n\n\n\n","category":"function"},{"location":"api/#MRIBuilder.Variables.variables.fall_time","page":"Internal API","title":"MRIBuilder.Variables.variables.fall_time","text":"fall_time(spoilt_slice_select)\n\nReturns the time of the SpoiltSliceSelect to return to zero.\n\n\n\n\n\n","category":"function"},{"location":"api/#MRIBuilder.Parts.SliceSelectRephases.SliceSelectRephase","page":"Internal API","title":"MRIBuilder.Parts.SliceSelectRephases.SliceSelectRephase","text":"SliceSelectRephase(pulse; kwargs...)\n\nCreates an excitatory RF pulse with slice selection and a rephasing gradient.\n\nParameters are the same as for SliceSelect.\n\n\n\n\n\n","category":"type"},{"location":"api/#MRIBuilder.Parts.EPIReadouts.EPIReadout","page":"Internal API","title":"MRIBuilder.Parts.EPIReadouts.EPIReadout","text":"EPIReadout(; resolution, ky_lines=-resolution[2]:resolution[2], recenter=false, group=:FOV, variables...)\n\nDefines an (accelerated) EPI readout.\n\nParameters\n\nvariables.resolution: Resolution of the final image in the frequency- and phase-encode directions.\nrecenter: if true, the signal will be recentred in k-space after the EPI readout.\ngroup: name of the group used to rotate the readout gradients (default: :FOV).\n\nVariables:\n\nvariables.voxel_size: size of the voxel in the frequency- and phase-encode directions.\nvariables.fov: size of the FOV in the frequency- and phase-encode directions.\nvariables.ramp_overlap: what fraction of the gradient ramp should overlap with the readout.\nvariables.oversample: by how much to oversample in the frequency-encode direcion.\nvariables.dwell_time: dwell time in the frequency-encode direction\n\n\n\n\n\n","category":"type"},{"location":"api/#Sequence-I/O","page":"Internal API","title":"Sequence I/O","text":"","category":"section"},{"location":"api/","page":"Internal API","title":"Internal API","text":"Modules = [\n    MRIBuilder.SequenceIO,\n    MRIBuilder.SequenceIO.Pulseq,\n    MRIBuilder.SequenceIO.PulseqIO,\n    MRIBuilder.SequenceIO.PulseqIO.Types,\n    MRIBuilder.SequenceIO.PulseqIO.Parsers,\n    MRIBuilder.SequenceIO.PulseqIO.BasicParsers,\n    MRIBuilder.SequenceIO.PulseqIO.Components,\n    MRIBuilder.SequenceIO.PulseqIO.SectionsIO,\n    MRIBuilder.SequenceIO.PulseqIO.ParseSections,\n]","category":"page"},{"location":"api/#MRIBuilder.SequenceIO.Pulseq","page":"Internal API","title":"MRIBuilder.SequenceIO.Pulseq","text":"Module converting MRIBuilder sequences to and from sequences recognised by PulseqIO.\n\n\n\n\n\n","category":"module"},{"location":"api/#MRIBuilder.SequenceIO.PulseqIO","page":"Internal API","title":"MRIBuilder.SequenceIO.PulseqIO","text":"Stand-alone module that reads/writes Pulseq files.\n\nThe pulseq files are read into or written from a set of types that closely match the Pulseq file format. The translation of these types into MRIBuilder types is defined in \"../pulseq.jl\" (i.e., MRIBuilder.SequenceIO.Pulseq)\n\n\n\n\n\n","category":"module"},{"location":"api/#MRIBuilder.SequenceIO.PulseqIO.read_pulseq-Tuple{IO}","page":"Internal API","title":"MRIBuilder.SequenceIO.PulseqIO.read_pulseq","text":"read_pulseq(IO)\n\nReads a sequence from a pulseq file (http://pulseq.github.io/). Pulseq files can be produced using matlab (http://pulseq.github.io/) or python (https://pypulseq.readthedocs.io/en/master/).\n\n\n\n\n\n","category":"method"},{"location":"api/#MRIBuilder.SequenceIO.PulseqIO.write_pulseq-Tuple{IO, MRIBuilder.SequenceIO.PulseqIO.Types.PulseqSequence}","page":"Internal API","title":"MRIBuilder.SequenceIO.PulseqIO.write_pulseq","text":"write_pulseq(IO, sequence)\n\nWrites a sequence to an output IO file.\n\n\n\n\n\n","category":"method"},{"location":"api/#MRIBuilder.SequenceIO.PulseqIO.Types","page":"Internal API","title":"MRIBuilder.SequenceIO.PulseqIO.Types","text":"Define the main types forming a PulseqSequence.\n\nExtensions and sections types are defined in their own modules.\n\n\n\n\n\n","category":"module"},{"location":"api/#MRIBuilder.SequenceIO.PulseqIO.Types.AnyPulseqComponent","page":"Internal API","title":"MRIBuilder.SequenceIO.PulseqIO.Types.AnyPulseqComponent","text":"Super-type for any RF pulses/gradients/ADC/extensions that can play out during a PulseqBlock.\n\n\n\n\n\n","category":"type"},{"location":"api/#MRIBuilder.SequenceIO.PulseqIO.Types.AnyPulseqGradient","page":"Internal API","title":"MRIBuilder.SequenceIO.PulseqIO.Types.AnyPulseqGradient","text":"Super-type of Pulseq gradients:\n\nPulseqGradient\nPulseqTrapezoid\n\n\n\n\n\n","category":"type"},{"location":"api/#MRIBuilder.SequenceIO.PulseqIO.Types.PulseqADC","page":"Internal API","title":"MRIBuilder.SequenceIO.PulseqIO.Types.PulseqADC","text":"PulseqADC(num::Int, dwell::Float64, delay::Int, frequency::Number, phase::Number)\n\nA trapezoidal gradient pulse defined in Pulseq (see specification).\n\n\n\n\n\n","category":"type"},{"location":"api/#MRIBuilder.SequenceIO.PulseqIO.Types.PulseqBlock","page":"Internal API","title":"MRIBuilder.SequenceIO.PulseqIO.Types.PulseqBlock","text":"PulseqBlock(duration::Int, rf::PulseqRFPulse, gx::AnyPulseqGradient, gy::AnyPulseqGradient, gz::AnyPulseqGradient, adc::PulseqADC, ext)\n\nDefines a Building Block with the Pulseq sequence (see specification).\n\nThe RF pulse, gradients, and ADC can be set to nothing.\n\nThe ext is a sequence of extension blocks that will be played out. Set this to a sequence of zero length to not have any extensions.\n\n\n\n\n\n","category":"type"},{"location":"api/#MRIBuilder.SequenceIO.PulseqIO.Types.PulseqExtension","page":"Internal API","title":"MRIBuilder.SequenceIO.PulseqIO.Types.PulseqExtension","text":"PulseqExtension(definition::PulseqExtensionDefinition, id::Int)\n\nReference to a specific implementation of a PulseqExtensionDefinition.\n\n\n\n\n\n","category":"type"},{"location":"api/#MRIBuilder.SequenceIO.PulseqIO.Types.PulseqExtensionDefinition","page":"Internal API","title":"MRIBuilder.SequenceIO.PulseqIO.Types.PulseqExtensionDefinition","text":"PulseqExtensionDefinition(name, content)\n\nAbstract definition of an unknown Pulseq extension.\n\n\n\n\n\n","category":"type"},{"location":"api/#MRIBuilder.SequenceIO.PulseqIO.Types.PulseqGradient","page":"Internal API","title":"MRIBuilder.SequenceIO.PulseqIO.Types.PulseqGradient","text":"PulseqGradient(amplitude::Number, shape::PulseqShape, time::PulseqShape, delay::int)\n\nA generic gradient waveform defined in Pulseq (see specification).\n\n\n\n\n\n","category":"type"},{"location":"api/#MRIBuilder.SequenceIO.PulseqIO.Types.PulseqRFPulse","page":"Internal API","title":"MRIBuilder.SequenceIO.PulseqIO.Types.PulseqRFPulse","text":"PulseqRFPulse(amplitude::Number, magnitude::PulseqShape, phase::PulseqShape, time::PulseqShape, delay::Int, frequency::Number, phase_offset::Number)\n\nAn RF pulse defined in Pulseq (see specification).\n\n\n\n\n\n","category":"type"},{"location":"api/#MRIBuilder.SequenceIO.PulseqIO.Types.PulseqSection","page":"Internal API","title":"MRIBuilder.SequenceIO.PulseqIO.Types.PulseqSection","text":"PulseqSection(:<title>)(lines)\n\nRepresents a section in the pulseq file format.\n\n\n\n\n\n","category":"type"},{"location":"api/#MRIBuilder.SequenceIO.PulseqIO.Types.PulseqSequence","page":"Internal API","title":"MRIBuilder.SequenceIO.PulseqIO.Types.PulseqSequence","text":"PulseqSequence(version::VersionNumber, definitions::NamedTuple, blocks::Vector{PulseqBlock})\n\nA full sequence defined according to the Pulseq specification.\n\n\n\n\n\n","category":"type"},{"location":"api/#MRIBuilder.SequenceIO.PulseqIO.Types.PulseqShape","page":"Internal API","title":"MRIBuilder.SequenceIO.PulseqIO.Types.PulseqShape","text":"PulseqShape(samples)\n\nDefine the shape of a PulseqRFPulse or PulseqGradient.\n\n\n\n\n\n","category":"type"},{"location":"api/#MRIBuilder.SequenceIO.PulseqIO.Types.PulseqTrapezoid","page":"Internal API","title":"MRIBuilder.SequenceIO.PulseqIO.Types.PulseqTrapezoid","text":"PulseqTrapezoid(amplitude::Number, rise::Int, flat::Int, fall::Int, delay::Int)\n\nA trapezoidal gradient pulse defined in Pulseq (see specification).\n\n\n\n\n\n","category":"type"},{"location":"api/#MRIBuilder.SequenceIO.PulseqIO.Parsers.gen_section","page":"Internal API","title":"MRIBuilder.SequenceIO.PulseqIO.Parsers.gen_section","text":"gen_section(sequence, Val(:<title>))\n\nCreates a specific PulseqSection{<title>} from a part of the PulseqSequence.\n\nThis is the opposite of parse_section\n\n\n\n\n\n","category":"function"},{"location":"api/#MRIBuilder.SequenceIO.PulseqIO.Parsers.parse_section","page":"Internal API","title":"MRIBuilder.SequenceIO.PulseqIO.Parsers.parse_section","text":"parse_section(section)\n\nParses any PulseqSection and return the appropriate type.\n\nThe opposite is gen_section.\n\n\n\n\n\n","category":"function"},{"location":"api/#MRIBuilder.SequenceIO.PulseqIO.BasicParsers.parse_pulseq_dict-Tuple{Any, Any, Any}","page":"Internal API","title":"MRIBuilder.SequenceIO.PulseqIO.BasicParsers.parse_pulseq_dict","text":"parse_pulseq_dict(line, names, dtypes)\n\nParse a line of integers/floats with known names and dtypes.\n\nThis is useful to parse most of the columnar data in Pulseq, such as in BLOCKS, RF, GRADIENTS, etc.\n\n\n\n\n\n","category":"method"},{"location":"api/#MRIBuilder.SequenceIO.PulseqIO.BasicParsers.parse_pulseq_properties-Tuple{Vector{<:AbstractString}}","page":"Internal API","title":"MRIBuilder.SequenceIO.PulseqIO.BasicParsers.parse_pulseq_properties","text":"parse_pulseq_properties(lines)\n\nParse any pulseq section formatted as:\n\n<name> <value>\n<name2> <value2>\n...\n\nThis includes the VERSION, DEFINITIONS, and part of the SHAPES\n\n\n\n\n\n","category":"method"},{"location":"api/#MRIBuilder.SequenceIO.PulseqIO.BasicParsers.parse_value-Tuple{AbstractString}","page":"Internal API","title":"MRIBuilder.SequenceIO.PulseqIO.BasicParsers.parse_value","text":"parse_value(string)\n\nTries to value the string as a number of sequence of numbers. If that does not work, the string is returned.\n\n\n\n\n\n","category":"method"},{"location":"api/#MRIBuilder.SequenceIO.PulseqIO.Components","page":"Internal API","title":"MRIBuilder.SequenceIO.PulseqIO.Components","text":"Define a list of all the PulseqShape and PulseqComponent that are used in a PulseqSequence.\n\n\n\n\n\n","category":"module"},{"location":"api/#MRIBuilder.SequenceIO.PulseqIO.Components.PulseqComponents","page":"Internal API","title":"MRIBuilder.SequenceIO.PulseqIO.Components.PulseqComponents","text":"PulseqComponents(shapes, pulses, grads, adcs, extensions)\n\nAll the shapes, pulses, grads, adcs, and extensions used in a PulseqSequence.\n\nThey can be provided as a dictionary from the integer ID to the object or as a vector.\n\n\n\n\n\n","category":"type"},{"location":"api/#MRIBuilder.SequenceIO.PulseqIO.Components.add_components!-Tuple{MRIBuilder.SequenceIO.PulseqIO.Components.PulseqComponents, Dict{Int64}, Nothing}","page":"Internal API","title":"MRIBuilder.SequenceIO.PulseqIO.Components.add_components!","text":"add_components(comp::PulseqComponents, search_vec::Vector, component)\nadd_components(comp::PulseqComponents, shape::PulseqShape)\n\nAdds a component to the search_vec, which is assumed to be the appropriate vector within the comp.\n\nIt will check whether the component is already part of the search_vec before adding it. The integer ID of the position of the component in search_vec is returned.\n\n0 is returned if component is nothing.\n\n\n\n\n\n","category":"method"},{"location":"api/#MRIBuilder.SequenceIO.PulseqIO.Components.same_component-Tuple{MRIBuilder.SequenceIO.PulseqIO.Components.PulseqComponents, Any, Any}","page":"Internal API","title":"MRIBuilder.SequenceIO.PulseqIO.Components.same_component","text":"same_component(comp::PulseqComponents, a, b)\n\nCheck whether components a and b are the same when using the shapes represented in comp.\n\n\n\n\n\n","category":"method"},{"location":"api/#MRIBuilder.SequenceIO.PulseqIO.Components.same_shape-Tuple{MRIBuilder.SequenceIO.PulseqIO.Types.PulseqShape, MRIBuilder.SequenceIO.PulseqIO.Types.PulseqShape}","page":"Internal API","title":"MRIBuilder.SequenceIO.PulseqIO.Components.same_shape","text":"same_component(a, b)\n\nCheck whether shapes a and b are the same.\n\n\n\n\n\n","category":"method"},{"location":"api/#MRIBuilder.SequenceIO.PulseqIO.SectionsIO","page":"Internal API","title":"MRIBuilder.SequenceIO.PulseqIO.SectionsIO","text":"Define IO for PulseqSection.\n\n\n\n\n\n","category":"module"},{"location":"api/#MRIBuilder.SequenceIO.PulseqIO.SectionsIO.parse_pulseq_sections-Tuple{IO}","page":"Internal API","title":"MRIBuilder.SequenceIO.PulseqIO.SectionsIO.parse_pulseq_sections","text":"parse_pulseq_sections(io)\n\nReads a Pulseq file into a dictionary of PulseqSection objects.\n\n\n\n\n\n","category":"method"},{"location":"api/#MRIBuilder.SequenceIO.PulseqIO.SectionsIO.write_pulseq_section-Union{Tuple{T}, Tuple{IO, MRIBuilder.SequenceIO.PulseqIO.Types.PulseqSection{T}}} where T","page":"Internal API","title":"MRIBuilder.SequenceIO.PulseqIO.SectionsIO.write_pulseq_section","text":"write_pulseq_section(io, section::PulseqSection)\n\nWrites a Pulseq section to the IO.\n\n\n\n\n\n","category":"method"},{"location":"api/#MRIBuilder.SequenceIO.PulseqIO.ParseSections","page":"Internal API","title":"MRIBuilder.SequenceIO.PulseqIO.ParseSections","text":"Translate between sets of PulseqSection objects and PulseqSequence.\n\n\n\n\n\n","category":"module"},{"location":"api/#MRIBuilder.SequenceIO.PulseqIO.ParseSections.parse_all_sections-Tuple{Dict{String, MRIBuilder.SequenceIO.PulseqIO.Types.PulseqSection}}","page":"Internal API","title":"MRIBuilder.SequenceIO.PulseqIO.ParseSections.parse_all_sections","text":"parse_all_sections(sections)\n\nParses the sections read from a Pulseq file.\n\nReturns a PulseqSequence\n\n\n\n\n\n","category":"method"},{"location":"api/#Plot","page":"Internal API","title":"Plot","text":"","category":"section"},{"location":"api/","page":"Internal API","title":"Internal API","text":"Modules = [\n    MRIBuilder.Plot,\n]","category":"page"},{"location":"api/#MRIBuilder.Plot.SequenceDiagram","page":"Internal API","title":"MRIBuilder.Plot.SequenceDiagram","text":"SequenceDiagram(; RFx, RFy, Gx, Gy, Gz, ADC)\n\nAll the lines forming a sequence diagram.\n\nEach parameter should be a SinglePlotLine if provided. Any parameters not provided will be set to a SinglePlotLine with zero amplitude.\n\n\n\n\n\n","category":"type"},{"location":"api/#MRIBuilder.Plot.SinglePlotLine","page":"Internal API","title":"MRIBuilder.Plot.SinglePlotLine","text":"SinglePlotLine(times, amplitudes, event_times, event_amplitudes)\n\nA single line in a sequence diagram (e.g., RFx, Gy, ADC).\n\n\n\n\n\n","category":"type"},{"location":"api/#MRIBuilder.Plot.plot_sequence","page":"Internal API","title":"MRIBuilder.Plot.plot_sequence","text":"plot_sequence(sequence; figure=(), axis=(), attributes...)\nplot(sequence; attributes...)\nplot!([scene,] sequence; attributes...)\n\nPlot the sequence diagram.\n\nCalling plot_sequence will result in a much cleaner sequence diagram (recommended). However, if you want to combine this diagram with other plots you will have to use plot or plot! instead.\n\nIf called as plot_sequence the user can also supply Makie.Figure (figure=(...)) and Makie.Axis (axis=(...)) keywords. If called using the plot or plot! interface, only the attributes listed below can be supplied\n\nThis function will only work if Makie is installed and imported.\n\nAttributes\n\nLine properties\n\nlinecolor sets the color of the lines. If you want to set the text color to the same value, you can also use color=....\nlinewidth=1.5 sets the width of the lines.\ninstant_width=3. sets the width of any instant gradients or pulses with respect to the linewidth.\n\nText properties\n\ntextcolor sets the color of the text. If you want to set the line color to the same value, you can also use color=....\nfont sets whether the rendered text is :regular, :bold, or :italic.\nfontsize: set the size of each character.\n\nBase.Docs.DocStr(svec(\"### Generic attributes\\n\\n- visible::Bool = true sets whether the plot will be rendered or not.\\n- overdraw::Bool = false sets whether the plot will draw over other plots. This specifically means ignoring depth checks in GL backends.\\n- transparency::Bool = false adjusts how the plot deals with transparency. In GLMakie transparency = true results in using Order Independent Transparency.\\n- fxaa::Bool = true adjusts whether the plot is rendered with fxaa (anti-aliasing).\\n- inspectable::Bool = true sets whether this plot should be seen by DataInspector.\\n- depth_shift::Float32 = 0f0 adjusts the depth value of a plot after all other transformations, i.e. in clip space, where 0 <= depth <= 1. This only applies to GLMakie and WGLMakie and can be used to adjust render order (like a tunable overdraw).\\n- model::Makie.Mat4f sets a model matrix for the plot. This replaces adjustments made with translate!, rotate! and scale!.\\n- space::Symbol = :data sets the transformation space for box encompassing the volume plot. See Makie.spaces() for possible inputs.\\n- clip_planes::Vector{Plane3f} = Plane3f[]: allows you to specify up to 8 planes behind which plot objects get clipped (i.e. become invisible). By default clip planes are inherited from the parent plot or scene.\\n\"), nothing, Dict{Symbol, Any}(:typesig => Tuple{Any}, :module => MakieCore, :linenumber => 4, :binding => MakieCore.genericplotattributes!, :path => \"/root/.julia/packages/MakieCore/NeQjl/src/basic_plots.jl\"))\n\n\n\n\n\n","category":"function"},{"location":"api/#MRIBuilder.Plot.range_event-Tuple{MRIBuilder.Plot.SinglePlotLine}","page":"Internal API","title":"MRIBuilder.Plot.range_event","text":"range_event(single_plot_line)\n\nReturns the minimum and maximum amplitude for the events in SinglePlotLine\n\n\n\n\n\n","category":"method"},{"location":"api/#MRIBuilder.Plot.range_line-Tuple{MRIBuilder.Plot.SinglePlotLine}","page":"Internal API","title":"MRIBuilder.Plot.range_line","text":"range_line(single_plot_line)\n\nReturns the minimum and maximum amplitude for a SinglePlotLine\n\n\n\n\n\n","category":"method"},{"location":"implemented_sequences/#implemented_sequences","page":"Implemented sequences","title":"Using implemented sequences","text":"","category":"section"},{"location":"implemented_sequences/#Usage","page":"Implemented sequences","title":"Usage","text":"","category":"section"},{"location":"implemented_sequences/","page":"Implemented sequences","title":"Implemented sequences","text":"MRIBuilder comes with several sequences pre-defined. Each sequence can be created through a simple function call. To get help on a specific sequence, either follow the link in the sequence list below or type ?<function_name> in Julia.","category":"page"},{"location":"implemented_sequences/","page":"Implemented sequences","title":"Implemented sequences","text":"When reading the help, you will notice that there are two type of expected inputs:","category":"page"},{"location":"implemented_sequences/","page":"Implemented sequences","title":"Implemented sequences","text":"Parameters: these define the type of components that will be included, e.g., the shape of the excitation pulse or the readout strategy. These parameters have to be set to certain fixed values. If not set, they will be determined by their default value as defined in the documentation.\nVariables: These are a special type of parameters. In addition to being set to a fixed value, they can also be set to :min or :max to minimise or maximise the variable. If they are not set, they will be determined based on the optimisation or fixing of other variables. For more details, see the section on sequence optimisation. All variables are available in the variables module. They can also be accessed as properties of the specific pulse/gradient/readout/block (i.e., block.<variable_name>).","category":"page"},{"location":"implemented_sequences/","page":"Implemented sequences","title":"Implemented sequences","text":"As an example, the following creates and plots a DiffusionSpinEcho that has a b-value of 1, a minimal echo time, and a slice thickness of 2 mm:","category":"page"},{"location":"implemented_sequences/","page":"Implemented sequences","title":"Implemented sequences","text":"using MRIBuilder\nusing CairoMakie\nsequence = DiffusionSpinEcho(bval=1., TE=:min, slice_thickness=2)\nf = plot(sequence)\nf\nsave(\"dwi_1_min_2.png\", f) # hide\nnothing # hide","category":"page"},{"location":"implemented_sequences/","page":"Implemented sequences","title":"Implemented sequences","text":"(Image: DWI sequence diagram)","category":"page"},{"location":"implemented_sequences/","page":"Implemented sequences","title":"Implemented sequences","text":"If we want a specific variables.diffusion_time, we can just add it to the constraints, and the rest of the sequence will adapt as needed:","category":"page"},{"location":"implemented_sequences/","page":"Implemented sequences","title":"Implemented sequences","text":"using MRIBuilder # hide\nusing CairoMakie # hide\nsequence = DiffusionSpinEcho(bval=1., diffusion_time=80, TE=:min, slice_thickness=2)\nf = plot(sequence)\nf\nsave(\"dwi_1_80_min_2.png\", f) # hide\nnothing # hide","category":"page"},{"location":"implemented_sequences/","page":"Implemented sequences","title":"Implemented sequences","text":"(Image: DWI sequence diagram with fixed diffusion time)","category":"page"},{"location":"implemented_sequences/","page":"Implemented sequences","title":"Implemented sequences","text":"We can even directly set some aspect of one of the sequence components, such as slowing down the gradient variables.rise_time and the additional constraint will just be included in the sequence optimisation:","category":"page"},{"location":"implemented_sequences/","page":"Implemented sequences","title":"Implemented sequences","text":"using MRIBuilder # hide\nusing CairoMakie # hide\nsequence = DiffusionSpinEcho(bval=1., diffusion_time=80, TE=:min, slice_thickness=2, gradient=(rise_time=15, ))\nf = plot(sequence)\nf\nsave(\"dwi_1_80_min_2_15.png\", f) # hide\nnothing # hide","category":"page"},{"location":"implemented_sequences/","page":"Implemented sequences","title":"Implemented sequences","text":"(Image: DWI sequence diagram with fixed diffusion time and rise time)","category":"page"},{"location":"implemented_sequences/","page":"Implemented sequences","title":"Implemented sequences","text":"Note that the previous sequences do not contain a realistic readout. Most sequences will only include an instant readout, unless you directly set the variables.voxel_size and variables.resolution.","category":"page"},{"location":"implemented_sequences/","page":"Implemented sequences","title":"Implemented sequences","text":"using MRIBuilder # hide\nusing CairoMakie # hide\nsequence = DiffusionSpinEcho(bval=1., TE=:min, voxel_size=2, resolution=(20, 20, 20))\nf = plot(sequence)\nf\nsave(\"dwi_1_80_min_2_15_epi.png\", f) # hide\nnothing # hide","category":"page"},{"location":"implemented_sequences/","page":"Implemented sequences","title":"Implemented sequences","text":"(Image: DWI sequence diagram with EPI readout)","category":"page"},{"location":"implemented_sequences/#Available-sequences","page":"Implemented sequences","title":"Available sequences","text":"","category":"section"},{"location":"implemented_sequences/","page":"Implemented sequences","title":"Implemented sequences","text":"CollapsedDocStrings = true","category":"page"},{"location":"implemented_sequences/","page":"Implemented sequences","title":"Implemented sequences","text":"Modules = [\n    MRIBuilder.Sequences,\n    MRIBuilder.Sequences.GradientEchoes,\n    MRIBuilder.Sequences.SpinEchoes,\n    MRIBuilder.Sequences.DiffusionSpinEchoes,\n]","category":"page"},{"location":"implemented_sequences/#MRIBuilder.Sequences.GradientEchoes.GradientEcho-Tuple{}","page":"Implemented sequences","title":"MRIBuilder.Sequences.GradientEchoes.GradientEcho","text":"GradientEcho(; echo_time, excitation=(), readout=(), optim=() resolution/fov/voxel_size/slice_thickness, scanner)\n\nDefines a gradient echo sequence with a single readout event.\n\nBy default, an instant excitation pulse and readout event are used. If image parameters are provided, this will switch to a sinc pulse and EPI readout.\n\nParameters\n\nexcitation: properties of the excitation pulse as described in excitation_pulse.\nreadout: properties of the readout as described in readout_event.\nImage parameters (variables.resolution/variables.fov/variables.voxel_size/variables.slice_thickness): describe the properties of the resulting image. See interpret_image_size for details.\noptim: parameters to pass on to the Ipopt optimiser (see https://coin-or.github.io/Ipopt/OPTIONS.html).\nscanner: Sets the Scanner used to constraint the gradient parameters. If not set, the Default_Scanner will be used.\n\nVariables\n\nvariables.TE/variables.echo_time: echo time between excitation pulse and readout in ms (required).\nvariables.duration: total duration of the sequence from start of excitation pulse to end of readout in ms.\n\n\n\n\n\n","category":"method"},{"location":"implemented_sequences/#MRIBuilder.Sequences.SpinEchoes.SpinEcho-Tuple{}","page":"Implemented sequences","title":"MRIBuilder.Sequences.SpinEchoes.SpinEcho","text":"SpinEcho(; echo_time, delay=0., excitation=(), refocus=(), readout=(), optim=(), resolution/fov/voxel_size/slice_thickness, scanner)\n\nDefines a gradient echo sequence with a single readout event.\n\nBy default, an instant excitation pulse and readout event are used. If image parameters are provided, this will switch to a sinc pulse and EPI readout.\n\nParameters\n\nexcitation: properties of the excitation pulse as described in excitation_pulse.\nrefocus: properties of the refocus pulse as described in refocus_pulse.\nreadout: properties of the readout as described in readout_event.\nImage parameters (variables.resolution/variables.fov/variables.voxel_size/variables.slice_thickness): describe the properties of the resulting image. See interpret_image_size for details.\noptim: parameters to pass on to the Ipopt optimiser (see https://coin-or.github.io/Ipopt/OPTIONS.html).\nscanner: Sets the Scanner used to constraint the gradient parameters. If not set, the Default_Scanner will be used.\n\nVariables\n\nvariables.TE/variables.echo_time: echo time between excitation pulse and spin echo in ms (required).\nvariables.delay: delay between the readout and the peak of the spin echo in ms (positive number indicates that readout is after the spin echo). Defaults to zero.\nvariables.duration: total duration of the sequence from start of excitation pulse to end of readout or spoiler in ms.\n\n\n\n\n\n","category":"method"},{"location":"implemented_sequences/#MRIBuilder.Variables.variables.echo_time","page":"Implemented sequences","title":"MRIBuilder.Variables.variables.echo_time","text":"echo_time(sequence)\n\nReturns the echo time of a sequence in ms.\n\nThis is typically defined as the time between the excitation pulse and the crossing of k=0 during the MRI readout.\n\n\n\n\n\n","category":"function"},{"location":"implemented_sequences/#MRIBuilder.Sequences.DiffusionSpinEchoes.DiffusionSpinEcho-Tuple{}","page":"Implemented sequences","title":"MRIBuilder.Sequences.DiffusionSpinEchoes.DiffusionSpinEcho","text":"DiffusionSpinEcho(; echo_time, delay=0., excitation=(), gradient=(), refocus=(), readout=(), optim=(), resolution/fov/voxel_size/slice_thickness, scanner)\n\nDefines a diffusion-weighted spin echo (Stejskal-Tanner) sequence.\n\nDWI, DW_SE, and DiffusionSpinEcho are all synonyms.\n\nBy default, an instant excitation pulse and readout event are used. If image parameters are provided, this will switch to a sinc pulse and EPI readout.\n\nParameters\n\nexcitation: properties of the excitation pulse as described in excitation_pulse.\ngradient: properties of the diffusion-weighting gradients as described in dwi_gradients.\nrefocus: properties of the refocus pulse as described in refocus_pulse.\nreadout: properties of the readout as described in readout_event.\nImage parameters (variables.resolution/variables.fov/variables.voxel_size/variables.slice_thickness): describe the properties of the resulting image. See interpret_image_size for details.\noptim: parameters to pass on to the Ipopt optimiser (see https://coin-or.github.io/Ipopt/OPTIONS.html).\nscanner: Sets the Scanner used to constraint the gradient parameters. If not set, the Default_Scanner will be used.\n\nVariables\n\nvariables.TE/variables.echo_time: echo time between excitation pulse and spin echo in ms.\nvariables.delay: delay between the readout and the peak of the spin echo in ms (positive number indicates that readout is after the spin echo). Defaults to zero.\nvariables.duration: total duration of the sequence from start of excitation pulse to end of readout or spoiler in ms.\nvariables.Δ/variables.diffusion_time: Time from the start of one diffusion-weighted gradient till the other in ms.\n\n\n\n\n\n","category":"method"},{"location":"implemented_sequences/#MRIBuilder.Variables.variables.delay","page":"Implemented sequences","title":"MRIBuilder.Variables.variables.delay","text":"delay(sequence)\n\nReturns the offset beetween the readout and the spin echo in ms.\n\n\n\n\n\n","category":"function"},{"location":"implemented_sequences/#MRIBuilder.Variables.variables.diffusion_time","page":"Implemented sequences","title":"MRIBuilder.Variables.variables.diffusion_time","text":"diffusion_time(diffusion_sequence)\n\nReturns the diffusion time of a DiffusionSpinEcho in ms.\n\n\n\n\n\n","category":"function"},{"location":"scanners/#scanners","page":"Scanners","title":"Scanners","text":"","category":"section"},{"location":"scanners/","page":"Scanners","title":"Scanners","text":"The MRI scanner that is used during acquisition puts various constraints on the MR sequences that can be used. These constraints include safety considerations, such as tissue heating, and hardware constraints, such as maximum gradient strength and slew rate. Currently, MRIBuilder only considers the latter.","category":"page"},{"location":"scanners/","page":"Scanners","title":"Scanners","text":"To define a sequence appropriate for a specific scanner, a user would define a new Scanner with the appropriate B0, maximum variables.gradient_strength, and maximum variables.slew_rate. This scanner would then be passed on to the sequence optimisation.","category":"page"},{"location":"scanners/","page":"Scanners","title":"Scanners","text":"For ease of use, the gradient_strength and slew_rate of many scanners have already been pre-defined. These are listed below.","category":"page"},{"location":"scanners/#Scanners-API","page":"Scanners","title":"Scanners API","text":"","category":"section"},{"location":"scanners/","page":"Scanners","title":"Scanners","text":"CollapsedDocStrings = true","category":"page"},{"location":"scanners/","page":"Scanners","title":"Scanners","text":"Modules = [\n    MRIBuilder.Scanners,\n]","category":"page"},{"location":"scanners/#MRIBuilder.Scanners","page":"Scanners","title":"MRIBuilder.Scanners","text":"Define general Scanner type and methods as well as some concrete scanners.\n\n\n\n\n\n","category":"module"},{"location":"scanners/#MRIBuilder.Scanners.Default_Scanner","page":"Scanners","title":"MRIBuilder.Scanners.Default_Scanner","text":"A default 1.5T scanner.\n\nMatches the one used in pulseq (https://github.com/pulseq/pulseq/blob/master/matlab/%2Bmr/opts.m).\n\n\n\n\n\n","category":"constant"},{"location":"scanners/#MRIBuilder.Scanners.Siemens_Connectom","page":"Scanners","title":"MRIBuilder.Scanners.Siemens_Connectom","text":"Siemens 3T Connectom MRI scanner (fan22_MappingHumanConnectome).\n\n\n\n\n\n","category":"constant"},{"location":"scanners/#MRIBuilder.Scanners.Siemens_Connectom_v2","page":"Scanners","title":"MRIBuilder.Scanners.Siemens_Connectom_v2","text":"Siemens 3T Connectom 2.0 MRI scanner (huang21_ConnectomeDevelopingnextgeneration)\n\n\n\n\n\n","category":"constant"},{"location":"scanners/#MRIBuilder.Scanners.Siemens_Prisma","page":"Scanners","title":"MRIBuilder.Scanners.Siemens_Prisma","text":"Siemens MAGNETOM 3T Prisma MRI scanner (https://www.siemens-healthineers.com/en-uk/magnetic-resonance-imaging/3t-mri-scanner/magnetom-prisma).\n\n\n\n\n\n","category":"constant"},{"location":"scanners/#MRIBuilder.Scanners.Siemens_Terra","page":"Scanners","title":"MRIBuilder.Scanners.Siemens_Terra","text":"Siemens MAGNETOM 7T Terra MRI scanner (https://www.siemens-healthineers.com/en-uk/magnetic-resonance-imaging/7t-mri-scanner/magnetom-terra)\n\n\n\n\n\n","category":"constant"},{"location":"scanners/#MRIBuilder.Scanners.Scanner","page":"Scanners","title":"MRIBuilder.Scanners.Scanner","text":"Scanner(;B0=3., gradient=Inf, slew_rate=Inf, units=:kHz)\n\nProperties of an MRI scanner relevant for the MR signal simulations.\n\nB0: magnetic field strength (in Tesla)\ngradient_strength: maximum gradient strength long each axis.\nslew_rate: maximum rate of change in the gradient strength\n\nBy default gradient and slew_rate are expected to be provided in units of, respectively, kHz/um and kHz/um/ms. However, if the keyword units=:Tesla is set, the gradient and slew_rate should be provided in units of, respectively, mT/m and T/m/s.\n\n\n\n\n\n","category":"type"},{"location":"scanners/#MRIBuilder.Scanners.B0-Tuple{Scanner}","page":"Scanners","title":"MRIBuilder.Scanners.B0","text":"B0(scanner)\nB0(sequence)\n\nReturns the magnetic field strength of the scanner in Tesla.\n\n\n\n\n\n","category":"method"},{"location":"scanners/#MRIBuilder.Scanners.gradient_strength","page":"Scanners","title":"MRIBuilder.Scanners.gradient_strength","text":"gradient_strength(scanner[, units])\n\nReturns the maximum magnetic field gradient of the scanner in kHz/um. By setting units to :Tesla, the gradient strength can be returned in mT/m instead.\n\n\n\n\n\n","category":"function"},{"location":"scanners/#MRIBuilder.Scanners.slew_rate","page":"Scanners","title":"MRIBuilder.Scanners.slew_rate","text":"slew_rate(scanner[, units])\n\nReturns the maximum magnetic field slew rate of the scanner in kHz/um/ms. By setting units to :Tesla, the slew rate can be returned in T/m/s instead.\n\n\n\n\n\n","category":"function"},{"location":"adjust_sequences/#adjust_sequences","page":"Post-hoc adjustments","title":"Post-hoc adjustment of sequences","text":"","category":"section"},{"location":"adjust_sequences/","page":"Post-hoc adjustments","title":"Post-hoc adjustments","text":"Typically a sequence is repeated for multiple repetition_time (TR) to allow the acquisition of multiple k-space lines, slice selection, or other sequence parameters (e.g., varying diffusion-weighting parameters for DiffusionSpinEcho). MRIBuilder supports this by allowing the creation of a longer sequence out of multiple repeats of a base sequence with some minor alterations.","category":"page"},{"location":"adjust_sequences/","page":"Post-hoc adjustments","title":"Post-hoc adjustments","text":"To support post-hoc alterations, each RF pulse or gradient waveform in the sequence can be given a label.  Some commonly-used labels in MRIBuilder are:","category":"page"},{"location":"adjust_sequences/","page":"Post-hoc adjustments","title":"Post-hoc adjustments","text":":diffusion used for diffusion-weighted gradients produced by dwi_gradients.\n:FOV used for gradients that should align with the field-of-view (slice-select gradients in excitation_pulse or refocus_pulse and readout gradients in readout_event).","category":"page"},{"location":"adjust_sequences/","page":"Post-hoc adjustments","title":"Post-hoc adjustments","text":"Post-hoc alterations can be applied to gradients or RF pulses with a specific labels (or to all gradients/RF pulses) using adjust. Some example usages are:","category":"page"},{"location":"adjust_sequences/","page":"Post-hoc adjustments","title":"Post-hoc adjustments","text":"Reduce the RF pulse amplitude by 20% (e.g., to model the effect of transmit bias field): adjust(sequence, pulse=(scale=0.8, ))\nRepeat sequence 2 times with different diffusion-weighted gradient orientations (x- and y-direction) and gradient strength reduced by 30%: adjust(sequence, diffusion=(orientation=[[1., 0., 0], [0., 1., 0.]], scale=0.7))\nRepeat the sequence by shifting the excited slice by the given number of millimetres in the slice-select direction: adjust(sequence, FOV=(shift=[-7.5, -2.5, 2.5, 7.5, -5., 0., 5., 10.])). These shifts represent an interleaved acquisition scheme, where the acquired slices/bands are 2.5 mm apart.\nRotations defined using the Rotations.jl package can be applied to gradient orientations or the field of view. For example, to rotate the field of view by 45 degrees around the y-axis:","category":"page"},{"location":"adjust_sequences/","page":"Post-hoc adjustments","title":"Post-hoc adjustments","text":"using Rotations\nrotation = Rotations.AngleAxis(deg2rad(45), 0., 1., 0.)\nadjust(sequence, FOV=(rotation=rotation, ))","category":"page"},{"location":"adjust_sequences/","page":"Post-hoc adjustments","title":"Post-hoc adjustments","text":"When repeating the same sequence, a spoiler gradient and/or dead time can be added in between each pair of repeats by supplying the appropriate keywords to the merge parameter in adjust (e.g., merge=(wait_time=10., )). These parameters are described in more detail in merge_sequences.","category":"page"},{"location":"adjust_sequences/#Post-hoc-adjustments-API","page":"Post-hoc adjustments","title":"Post-hoc adjustments API","text":"","category":"section"},{"location":"adjust_sequences/","page":"Post-hoc adjustments","title":"Post-hoc adjustments","text":"CollapsedDocStrings = true","category":"page"},{"location":"adjust_sequences/","page":"Post-hoc adjustments","title":"Post-hoc adjustments","text":"Modules = [\n    MRIBuilder.PostHoc,\n]","category":"page"},{"location":"adjust_sequences/#MRIBuilder.PostHoc","page":"Post-hoc adjustments","title":"MRIBuilder.PostHoc","text":"Define post-fitting adjustments of the sequences\n\n\n\n\n\n","category":"module"},{"location":"adjust_sequences/#MRIBuilder.PostHoc.merge_sequences-Union{Tuple{Vararg{Sequence{S}}}, Tuple{S}} where S","page":"Post-hoc adjustments","title":"MRIBuilder.PostHoc.merge_sequences","text":"merge_sequences(sequences...; wait_time=0.)\n\nMerge multiple sequences together.\n\nSequences will be run one after each other with wait_time in between.\n\n\n\n\n\n","category":"method"},{"location":"adjust_sequences/#MRIBuilder.Variables.adjust-Tuple{MRIBuilder.Variables.AbstractBlock}","page":"Post-hoc adjustments","title":"MRIBuilder.Variables.adjust","text":"adjust(block; kwargs...)\n\nGenerate one or more new sequences/building_blocks/components with some post-fitting adjustments.\n\nThe following adjustments are allowed:\n\nfor MR gradients\norientation: set the orientation to a given vector.\nrotation: rotate the gradient orientations using a rotations from Rotations.jl.\nscale: multiply the gradient strength by the given value. Note that if you use a value not between -1 and 1 you might break the scanner's maximum gradient or slew rate.\nfor RF pulses:\nfrequency: shift the off-resonance frequency by the given value (in kHz).\nscale: multiply the RF pulse amplitude by the given value (used to model the B1 transmit field).\n\nA vector of multiple values can be passed on to any of these in order to create multiple sequences with different adjustments. The will usually be merged together. You can get the individual sequences by passing on merge=false. The time between these repeated sequences can be adjusted using the keywords described in merge_sequences passed on to the merge keyword: e.g., merge=(wait_time=10, ) adds a wait time of 10 ms between each repeated sequence.\n\nSpecific sequence components that can be adjusted are identified by their group name. For example, adjust(sequence, diffusion=(orientation=[0, 1, 0], )) will set any gradient in the group :diffusion to point in the y-direction.\n\nTo affect all gradients or pulses, use gradient= or pulse, e.g. adjust(sequence, pulse=(scale=0.5, )) will divide the amplitude of all RV pulses by two.\n\n\n\n\n\n","category":"method"},{"location":"defining_sequence/#defining_sequences","page":"Defining sequences","title":"Defining new sequences","text":"","category":"section"},{"location":"defining_sequence/","page":"Defining sequences","title":"Defining sequences","text":"Examples of sequence definitions can be found here. These are the actual sequence definitions used for the pre-implemented sequences in MRIBuilder. In this example, we will look at the file for DiffusionSpinEcho as an example. ","category":"page"},{"location":"defining_sequence/","page":"Defining sequences","title":"Defining sequences","text":"We can see that there are several steps. First we define the sequence as a specific sub-type of Sequence:","category":"page"},{"location":"defining_sequence/","page":"Defining sequences","title":"Defining sequences","text":"const DiffusionSpinEcho = Sequence{:DiffusionSpinEcho}","category":"page"},{"location":"defining_sequence/","page":"Defining sequences","title":"Defining sequences","text":"Note the duplication of the sequence name (DiffusionSpinEcho). This name will have to be unique.","category":"page"},{"location":"defining_sequence/","page":"Defining sequences","title":"Defining sequences","text":"The next step is to define the sequence constructor:","category":"page"},{"location":"defining_sequence/","page":"Defining sequences","title":"Defining sequences","text":"function DiffusionSpinEcho(; scanner=DefaultScanner, parameters..., vars...)\n    build_sequence(scanner) do\n        (g1, g2) = dwi_gradients(...)\n        seq = Sequence([\n            :excitation => excitation_pulse(...),\n            nothing,\n            :gradient => g1,\n            nothing,\n            :refocus => refocus_pulse(...),\n            nothing,\n            g2,\n            nothing,\n            :readout => readout_event(...),\n            nothing,\n        ], name=:DiffusionSpinEcho, vars...)\n        add_cost_function!(seq[6].duration + seq[7].duration)\n        return seq\n    end\nend","category":"page"},{"location":"defining_sequence/","page":"Defining sequences","title":"Defining sequences","text":"The crucial part here are the individual parts used to build the sequence, defined as a vector:","category":"page"},{"location":"defining_sequence/","page":"Defining sequences","title":"Defining sequences","text":"[\n    :excitation => excitation_pulse(...),\n    nothing,\n    :gradient => g1,\n    nothing,\n    :refocus => refocus_pulse(...),\n    nothing,\n    :gradient2 => g2,\n    nothing,\n    :readout => readout_event(...),\n    nothing\n]","category":"page"},{"location":"defining_sequence/","page":"Defining sequences","title":"Defining sequences","text":"We can see that this sequence is built in order by an excitation pulse, some unknown dead time (indicated by nothing), a gradient, more dead time, a refocus pulse, more dead time, another gradient, more dead time, and finally a readout.","category":"page"},{"location":"defining_sequence/","page":"Defining sequences","title":"Defining sequences","text":"Some of these components have been given specific names (e.g., :excitation => ...). This is optional, but can be useful to refer to individual components. There are helper functions available to create these components.","category":"page"},{"location":"defining_sequence/","page":"Defining sequences","title":"Defining sequences","text":"After creating the sequence object, we can now add secondary objectives to the cost function (using add_cost_function!). In this example, we have:","category":"page"},{"location":"defining_sequence/","page":"Defining sequences","title":"Defining sequences","text":"add_cost_function!(seq[6].duration + seq[7].duration)","category":"page"},{"location":"defining_sequence/","page":"Defining sequences","title":"Defining sequences","text":"If we check the order of the sequence component, we see that this minimises the sum of the duration of the second gradient and the wait block before this gradient. This cost function has been added to maximise the time between the second gradient and the readout (and hence minimise the effect of eddy currents on the readout). Note that this is a secondary cost function that will only take effect if it does not interfere with any user-defined constraints and cost functions (see sequence optimisation). Some secondary cost functions will be automatically defined for you within the individual components (e.g., a trapezoidal gradient has a secondary cost function to maximise the slew rate). There is even a tertiary cost function, which minimises the total sequence duration.","category":"page"},{"location":"defining_sequence/","page":"Defining sequences","title":"Defining sequences","text":"The next step is to define summary variables that the user can constrain when setting up a specific instance of this sequence:","category":"page"},{"location":"defining_sequence/","page":"Defining sequences","title":"Defining sequences","text":"@defvar begin\n    diffusion_time(ge::DiffusionSpinEcho) = start_time(ge, :gradient2) - start_time(ge, :gradient)\n    echo_time(ge::DiffusionSpinEcho) = 2 * (variables.effective_time(ge, :refocus) - variables.effective_time(ge, :excitation))\nend","category":"page"},{"location":"defining_sequence/","page":"Defining sequences","title":"Defining sequences","text":"For this sequence, we define the variables.diffusion_time as the time between the start of the first and second gradient pulse, and the variables.echo_time as twice the time between the refocus and excitation pulses. These variables need to be defined within a @defvar block.","category":"page"},{"location":"defining_sequence/","page":"Defining sequences","title":"Defining sequences","text":"In addition to these sequence-specific summary variables, there are also a lot of variables already pre-defined on individual components, such as the variables.slice_thickness of the RF pulse or the variables.gradient_strength of the gradient pulses. To access these summary variables on a sequence-level, we need to tell MRIBuilder for which RF pulses/gradients we are interested in computing these variables:","category":"page"},{"location":"defining_sequence/","page":"Defining sequences","title":"Defining sequences","text":"get_pulse(seq::DiffusionSpinEcho) = (excitation=seq[:excitation], refocus=seq[:refocus])\nget_gradient(seq::DiffusionSpinEcho) = (gradient=seq[:gradient], gradient2=seq[:gradient2])\nget_readout(seq::DiffusionSpinEcho) = seq.readout","category":"page"},{"location":"defining_sequence/","page":"Defining sequences","title":"Defining sequences","text":"Note that we can indicate we are interested in multiple RF pulses/gradients by supplying them as a named tuple ((excitation=..., refocus=...)).","category":"page"},{"location":"defining_sequence/","page":"Defining sequences","title":"Defining sequences","text":"Setting this allows us to get RF pulse or gradient-specific properties by calling the sequence, for example:","category":"page"},{"location":"defining_sequence/","page":"Defining sequences","title":"Defining sequences","text":"using MRIBuilder\nsequence = DiffusionSpinEcho(bval=1., TE=:min, slice_thickness=2.)\nvariables.flip_angle(sequence)","category":"page"},{"location":"defining_sequence/","page":"Defining sequences","title":"Defining sequences","text":"Here we can see that we get the variables.flip_angle for each of the two RF pulses defined using get_pulse above.","category":"page"},{"location":"defining_sequence/","page":"Defining sequences","title":"Defining sequences","text":"The final component to defining summary variables is to define one or more default coherence pathways using get_pathway:","category":"page"},{"location":"defining_sequence/","page":"Defining sequences","title":"Defining sequences","text":"get_pathway(seq::DiffusionSpinEcho) = Pathway(seq, [90, 180], 1, group=:diffusion)","category":"page"},{"location":"defining_sequence/","page":"Defining sequences","title":"Defining sequences","text":"Here the coherence Pathway sets out what a specific set of spins might experience during the sequence. In this case the sequence experiences two RF pulses and is excited by the first pulse and flipped by the second ([90, 180]). It is then observed during the first readout (1).  For such a Pathway we can compute:","category":"page"},{"location":"defining_sequence/","page":"Defining sequences","title":"Defining sequences","text":"the time that the spin spends in each longitudinal and transverse direction, which is particularly useful in the transverse direction to compute the amount of T2-weighting (variables.duration_transverse) and the amount of time spent dephasing to compute the amount of T2*-weighting (variables.duration_dephase).\nthe diffusion weighting experienced (variables.bval, variables.bmat, and variables.net_dephasing)","category":"page"},{"location":"defining_sequence/","page":"Defining sequences","title":"Defining sequences","text":"By defining a default pathway for the sequence, the user can now put constraints on any or all of these variables.","category":"page"},{"location":"defining_sequence/#helper_functions","page":"Defining sequences","title":"Component helper functions","text":"","category":"section"},{"location":"defining_sequence/","page":"Defining sequences","title":"Defining sequences","text":"CollapsedDocStrings = true","category":"page"},{"location":"defining_sequence/","page":"Defining sequences","title":"Defining sequences","text":"Modules = [\n    MRIBuilder.Parts.HelperFunctions,\n]","category":"page"},{"location":"defining_sequence/#MRIBuilder.Parts.HelperFunctions.dwi_gradients-Tuple{}","page":"Defining sequences","title":"MRIBuilder.Parts.HelperFunctions.dwi_gradients","text":"dwi_gradients(; type, optimise=false, refocus=true, orientation=[1, 0, 0], group=:diffusion, variables...)\n\nReturns two diffusion-weighting gradients that are guaranteed to cancel each other out.\n\nParameters\n\ntype: A symbol describing the type of gradient. One of:\n:trapezoid: Pulsed trapezoidal gradient profile. See Trapezoid for the relevant variables.\n:instant: instantaneous gradient (e.g., to test short-pulse approximations). See InstantGradient for the relevant variables.\noptimise: Whether to optimise this readout event in isolation from the rest of the sequence. Use this with caution. It can speed up the optimisation (and for very complicated sequences make it more robust), however the resulting parameters might not represent the optimal solution of any external constraints (which are ignored if the readout is optimised in isolation).\nscanner: Used for testing. Do not set this parameter at this level (instead set it for the total sequence using build_sequence).\n\n\n\n\n\n","category":"method"},{"location":"defining_sequence/#MRIBuilder.Parts.HelperFunctions.excitation_pulse-Tuple{}","page":"Defining sequences","title":"MRIBuilder.Parts.HelperFunctions.excitation_pulse","text":"excitation_pulse(; parameters...)\n\nCreate an excitation RF pulse.\n\nBy default there is no slice-selective gradient.  To enable slice selection min_slice_thickness has to be set to a number or to :min. If min_slice_thickness is not set or is set to :min, then either bandwidth or duration should be set, otherwise the optimisation might be unconstrained (ignore this for shape=:instant).\n\nParameters\n\nFor an InstantPulse (i.e., shape=:instant), only the flip_angle, phase, and group will be used. All other parameters are ignored.\n\noptimise: set to true to optimise this RF pulse separately from the embedding sequence.\n\nPulse parameters\n\nshape: The shape of the RF pulse. One of :sinc (for SincPulse), :constant/:hard (for ConstantPulse), or :instant (for InstantPulse). Default is :sinc for slice-selective pulses or :instant otherwise.\nflip_angle: size of the flip due to the RF pulse in degrees (default: 90).\nphase: angle of the RF pulse in the x-y plane in degrees (default: 0).\nfrequency: frequency of the RF pulse relative to the Larmor frequency in kHz (default: 0).\nbandwidth: width of the RF pulse in Fourier space in kHz (default: free variable).\nduration: duration of the RF pulse in ms (default: free variable).\nNzeros: sets the number of zero crossings for a SincPulse (default: 3). Can be set to a tuple of two numbers to set a different number of zero crossings before and after the pulse maximum.\ngroup: name of the group of which the RF pulse is part. This is used to add transformations after the sequence is optimised.\n\nSlice selection\n\nslice_thickness: minimum slice thickness that should be possible without adjusting the sequence timings in um (not mm!) (default: no slice selection). Can be set to :min to indicate that this should be minimised given the scanner constraints and user values for bandwidth or duration.\nrephase: set to false to disable the spin rephasing after the RF pulse.\nrotate_grad: name of the parameter with which the slice selection gradient will be rotated after sequence optimisation (default: :FOV).\nscanner: overrides the global_scanner for this part of the sequence. Recommended to set only if not part of a larger sequence.\n\n\n\n\n\n","category":"method"},{"location":"defining_sequence/#MRIBuilder.Parts.HelperFunctions.gradient_spoiler-Tuple{}","page":"Defining sequences","title":"MRIBuilder.Parts.HelperFunctions.gradient_spoiler","text":"gradient_spoiler(; optimise=false, orientation=[0, 0, 1], rotate=:FOV, scale=:spoiler, spoiler=1., duration=:min, variables...)\n\nReturns two DWI gradients that are guaranteed to cancel each other out.\n\nParameters\n\norientation: Orientation of the gradient (default: slice-select direction).\nrotate: in which coordinate system is the orientation defined (default: :FOV).\nscale: variable controlling how the gradients should be scaled after optimsation (default: :spoiler).\noptimise: Whether to optimise this readout event in isolation from the rest of the sequence. Use this with caution. It can speed up the optimisation (and for very complicated sequences make it more robust), however the resulting parameters might not represent the optimal solution of any external constraints (which are ignored if the readout is optimised in isolation).\nscanner: Used for testing. Do not set this parameter at this level (instead set it for the total sequence using build_sequence).\n\nVariables\n\nvariables.spoiler: maximum spoiler scale (before applying any reductions due to scale).\nAny other parameters expected by Trapezoid.\n\n\n\n\n\n","category":"method"},{"location":"defining_sequence/#MRIBuilder.Parts.HelperFunctions.interpret_image_size-NTuple{4, Any}","page":"Defining sequences","title":"MRIBuilder.Parts.HelperFunctions.interpret_image_size","text":"interpret_image_size(fov, resolution, voxel_size, slice_thickness)\n\nCombines the user-provided information of the image size to produce a tuple with:\n\nslice_thickness: if not set explicitly, will be set to the third element of voxel_size\nresolution_z: number of voxels in the slice-select direction.\nkeywords parameters for the readout_event functions with the fov, resolution, and voxel_size in the x- and y- dimensions.\n\n\n\n\n\n","category":"method"},{"location":"defining_sequence/#MRIBuilder.Parts.HelperFunctions.readout_event-Tuple{}","page":"Defining sequences","title":"MRIBuilder.Parts.HelperFunctions.readout_event","text":"readout_event(; type, optimise=false, variables...)\n\nAdds a readout event to the sequence.\n\nParameters\n\ntype: A symbol describing the type of readout. It will default to :epi if a resolution has been set and :instant otherwise. Can be set to one of the following:\n:epi: EPI readout. See EPIReadout for the relevant variables.\n:instant: single isolated readout event SingleReadout (e.g., for NMR). Does not expect any variables.\noptimise: Whether to optimise this readout event in isolation from the rest of the sequence. Use this with caution. It can speed up the optimisation (and for very complicated sequences make it more robust), however the resulting parameters might not represent the optimal solution of any external constraints (which are ignored if the readout is optimised in isolation).\nscanner: Used for testing. Do not set this parameter at this level (instead set it for the total sequence using build_sequence).\n\n\n\n\n\n","category":"method"},{"location":"defining_sequence/#MRIBuilder.Parts.HelperFunctions.refocus_pulse-Tuple{}","page":"Defining sequences","title":"MRIBuilder.Parts.HelperFunctions.refocus_pulse","text":"refocus_pulse(; parameters...)\n\nCreate an excitation RF pulse.\n\nBy default there is no slice-selective gradient.  To enable slice selection slice_thickness has to be set to a number or to :min. If slice_thickness is not set or is set to :min, then either bandwidth or duration should be set, otherwise the optimisation might be unconstrained (ignore this for shape=:instant).\n\nParameters\n\noptimise: set to true to optimise this RF pulse separately from the embedding sequence.\n\nPulse parameters\n\nFor an InstantPulse (i.e., shape=:instant), only the flip_angle, phase, and group will be used. All other parameters are ignored.\n\nshape: The shape of the RF pulse. One of :sinc (for SincPulse), :constant/:hard (for ConstantPulse), or :instant (for InstantPulse). Default is :sinc for slice-selective pulses or :instant otherwise.\nflip_angle: size of the flip due to the RF pulse in degrees (default: 180).\nphase: angle of the RF pulse in the x-y plane in degrees (default: 0).\nfrequency: frequency of the RF pulse relative to the Larmor frequency in kHz (default: 0).\nbandwidth: width of the RF pulse in Fourier space in kHz (default: free variable).\nduration: duration of the RF pulse in ms (default: free variable).\nNzeros: sets the number of zero crossings for a SincPulse (default: 3). Can be set to a tuple of two numbers to set a different number of zero crossings before and after the pulse maximum.\ngroup: name of the group of which the RF pulse is part. This is used to add transformations after the sequence is optimised.\n\nSlice selection and spoilers\n\nslice_thickness: minimum slice thickness that should be possible without adjusting the sequence timings in um (not mm!) (default: no slice selection). Can be set to :min to indicate that this should be minimised given the scanner constraints and user values for bandwidth or duration.\nspoiler: set to the spatial scale on which the spins should be dephased in mm. For rotating spoilers, this does include the contribution from the slice select gradient as well.\nrotate_grad: name of the parameter with which the slice selection and spoiler gradient will be rotated after sequence optimisation (default: :FOV).\nscanner: overrides the global_scanner for this part of the sequence. Recommended to set only if not part of a larger sequence.\norientation: vector with orientation of slice select gradient and pulses (defaults: z-direction).\n\n\n\n\n\n","category":"method"},{"location":"defining_sequence/#MRIBuilder.Parts.HelperFunctions.saturation_pulse-Tuple{}","page":"Defining sequences","title":"MRIBuilder.Parts.HelperFunctions.saturation_pulse","text":"saturation_pulse(; pulse=(), binomial_order=1, variables...)\n\nCreates a saturation pulse consisting of repeating instances of pulse_type.\n\nParameters\n\npulse: Parameters/variables used to define the basic RF pulse used in the saturation pulse. These can be:\ntype: ConstantPulse (default), SincPulse, InstantPulse, etc.\nVariables describing that type (e.g., flip_angle, duration, frequency)\nbinomial_order: How many repeats of pulse_type there should be in a single binomial pulse.\n\nVariables\n\nnrepeat: number of repeats of the binomial pulse. This should typically be set by the user.\ninterblock_delay: time between the start of each pulse. Should be short compared with the T1, but long enough to limit SAR.\nduration: total duration of the saturation pulse.\n\n\n\n\n\n","category":"method"},{"location":"defining_sequence/#Optimisation-helper-functions","page":"Defining sequences","title":"Optimisation helper functions","text":"","category":"section"},{"location":"defining_sequence/","page":"Defining sequences","title":"Defining sequences","text":"Modules = [\n    MRIBuilder.BuildSequences,\n]","category":"page"},{"location":"defining_sequence/#MRIBuilder.BuildSequences.build_sequence-Tuple{Function, Union{Nothing, Scanner}, Tuple, Bool, Int64}","page":"Defining sequences","title":"MRIBuilder.BuildSequences.build_sequence","text":"Wrapper to build a sequence.\n\nUse as \n\nbuild_sequence(scanner;) do\n    ...\nend\n\nWithin the code block you can create one or more sequences, e.g.\n\nseq = Sequence(\n    SincPulse(flip_angle=90, phase=0, duration=2., bandwidth=:max)\n    nothing.,\n    SingleReadout\n)\n\nYou can also add any arbitrary constraints or objectives using one of:\n\nset_simple_constraints!\napply_simple_constraint!\nadd_cost_function!\n\nAs soon as the code block ends the sequence is optimised (if optimise=true) and returned.\n\nParameters\n\nscanner: Set to a Scanner to limit the gradient strength and slew rate. When this call to build_sequence is embedded in another, this parameter can be set to nothing to indicate that the same scanner should be used. \noptimise: Whether to optimise and fix the sequence as soon as it is returned. This defaults to true if a scanner is provided and false if no scanner is provided.\nn_attempts: How many times to restart the optimiser (default: 20)? Decrease if you want to quickly check feasibility of a simple sequence. Increase if convergence fails for a complex sequence.\nkwargs...: Other keywords are passed on as attributes to the optimiser_constructor (e.g., set print_level=3 to make the Ipopt optimiser quieter).\n\n\n\n\n\n","category":"method"},{"location":"defining_sequence/#MRIBuilder.BuildSequences.fixed-Tuple{Any}","page":"Defining sequences","title":"MRIBuilder.BuildSequences.fixed","text":"fixed(building_block)\n\nReturn an equiavalent BuildingBlock with all free variables replaced by numbers.\n\nThis will only work after calling optimize!(@ref)(global_model()). It is used internally by build_sequence.\n\n\n\n\n\n","category":"method"},{"location":"defining_sequence/#MRIBuilder.BuildSequences.get_optimiser-Tuple{JuMP.Model}","page":"Defining sequences","title":"MRIBuilder.BuildSequences.get_optimiser","text":"get_optimiser(model)\n\nReturns a JuMP solver (https://jump.dev/JuMP.jl/stable/installation/#Supported-solvers) appropriate for this model.\n\n\n\n\n\n","category":"method"},{"location":"defining_sequence/#MRIBuilder.BuildSequences.global_scanner-Tuple{}","page":"Defining sequences","title":"MRIBuilder.BuildSequences.global_scanner","text":"global_scanner()\n\nReturn the currently set Scanner.\n\nThe scanner can be set using build_sequence\n\n\n\n\n\n","category":"method"},{"location":"defining_sequence/#MRIBuilder.BuildSequences.iterate_cost-Tuple{}","page":"Defining sequences","title":"MRIBuilder.BuildSequences.iterate_cost","text":"iterate_cost()\n\nReturn a sequence of all the cost functions that should be optimised in order.\n\n\n\n\n\n","category":"method"},{"location":"defining_sequence/#MRIBuilder.BuildSequences.model_has_integers-Tuple{JuMP.Model}","page":"Defining sequences","title":"MRIBuilder.BuildSequences.model_has_integers","text":"model_has_integers(model)\n\nReturns true if the model contains integer variables.\n\n\n\n\n\n","category":"method"},{"location":"defining_sequence/#Pathways-API","page":"Defining sequences","title":"Pathways API","text":"","category":"section"},{"location":"defining_sequence/","page":"Defining sequences","title":"Defining sequences","text":"Modules = [\n    MRIBuilder.Pathways,\n]","category":"page"},{"location":"defining_sequence/#MRIBuilder.Pathways.GradientTracker","page":"Defining sequences","title":"MRIBuilder.Pathways.GradientTracker","text":"Helper structure for PathwayWalker, which is itself a helper for Pathway.  You are deep down the rabit hole now...\n\nFor documentation, see that structure and walk_pathway! and update_walker_gradient!.\n\n\n\n\n\n","category":"type"},{"location":"defining_sequence/#MRIBuilder.Pathways.Pathway","page":"Defining sequences","title":"MRIBuilder.Pathways.Pathway","text":"Pathway(sequence::Sequence, pulse_effects::Vector{:Symbol/Number}, readout_index=1; group=nothing)\n\nDescribes how a specific spin/isochromat might experience the sequence.\n\nOnly a single pathway through the RF pulses is considered, so that at every point in time the spins are in one of the following four states:\n\n+longitudinal: initial relaxed state\n+transverse: excited state. During this time gradients will affect the variables.area_under_curve (or variables.qval) and variables.bval.\n-longitudinal: inverse state\n-transverse: inverse excited state. During this time all gradients will have the inverse effect compared with +transverse.\n\nThe RF pulses cause mappings between these different states as described below.\n\nParameters\n\nsequence: MRI Sequence to be considered.\npulse_effects: How each RF pulse affects the spins. This can be one of the following:\n:skip/:ignore/0: This RF pulse leaves the spins unaffected.\n:refocus/:invert/180: Flips the sign of the spin state (i.e., +longitudinal <-> -longitudinal, +transverse <-> -transverse)\n:excite/90: Takes spin state one step along the following sequence +longitudinal -> +transverse -> -longitudinal -> -transverse -> +longitudinal\n:neg_excite/270/-90: Inverse step compared with :excite.\nreadout_index: After encountering the number of pulses as defined in pulse_effects, continue the Pathway until the readout given by index is reached. If set to 0 the Pathway is terminated immediately after the last RF pulse.\ngroup: which gradient grouping to consider for the net_dephasing and bmat. If not set, all gradients will be considered (using their current alignment).\n\nAttributes\n\nOver the pathway the following values are computed. Each can be accessed by calling the appropriate function:\n\nTimings\n\nvariables.duration_state: The total amount of time spent in a specific state in this pathway (+longitudinal, +transverse, -longitudinal, or -transverse)\nvariables.duration_transverse: The total amount of time the spins spent in the transverse plane in ms. This can be used to quantify the expected effect of T2-decay.\nvariables.duration_dephase: The total amount of time the spins spent in the +transverse relative to -transverse state in ms. The absolute value of this can be used to quantify the expected effect of T2'-decay.\n\nEffect of gradients\n\nThe area under curve, q-values, and b-values are computed separately for each group of gradients (depending on the group keyword set during construction).\n\nvariables.net_dephasing: Net displacement vector in k-space/q-space.\nvariables.bmat: Net diffusion weighting due to gradients along the Pathway in matrix form.\nvariables.bval: Net diffusion weighting due to gradients along the Pathway as a single number.\n\n\n\n\n\n","category":"type"},{"location":"defining_sequence/#MRIBuilder.Pathways.PathwayWalker","page":"Defining sequences","title":"MRIBuilder.Pathways.PathwayWalker","text":"Helper structure for Pathway.\n\nFor documentation, see that structure and walk_pathway!.\n\n\n\n\n\n","category":"type"},{"location":"defining_sequence/#MRIBuilder.Pathways.duration_state_index-Tuple{Any, Any}","page":"Defining sequences","title":"MRIBuilder.Pathways.duration_state_index","text":"duration_state_index(transverse, positive)\n\nReturns the index of a specific state in the Pathway.duration_state vector.\n\nThis function is used internally to access that vector.\n\n\n\n\n\n","category":"method"},{"location":"defining_sequence/#MRIBuilder.Pathways.interpret_pulse_effects-Tuple{Number}","page":"Defining sequences","title":"MRIBuilder.Pathways.interpret_pulse_effects","text":"interpret_pulse_effects(number_or_symbol)\n\nInterpret the various numbers and symbols that can be passed on to a Pathway.\n\nThe result will be one of:\n\n:ignore (if input is 0, :ignore, or :skip).\n:excite (if input is 90 or :excite).\n:refocus (if input is 180, :refocus, or :excite).\n:neg_excite (if input is -90, 270, or :negexcite).\n\n\n\n\n\n","category":"method"},{"location":"defining_sequence/#MRIBuilder.Pathways.update_gradient_tracker_till_time!-Tuple{MRIBuilder.Pathways.PathwayWalker, Union{Nothing, Symbol}, Union{Number, JuMP.AbstractJuMPScalar}}","page":"Defining sequences","title":"MRIBuilder.Pathways.update_gradient_tracker_till_time!","text":"update_gradient_tracker_till_time!(walker::PathwayWalker, key, new_time)\nupdate_gradient_tracker_till_time!(tracker::GradientTracker, new_time)\n\nUpdate the bmat for any time passed since the last update (assuming there will no gradients during that period).\n\nThe bmat is updated with the outer produce of qvec with itself multiplied by the time since the last update.\n\nWhen called with the first signature the tracker will be created from scratch if a tracker with that key does not exist.\n\n\n\n\n\n","category":"method"},{"location":"defining_sequence/#MRIBuilder.Pathways.update_walker_gradient!-Tuple{MRIBuilder.Components.GradientWaveforms.NoGradientBlocks.NoGradient, MRIBuilder.Pathways.PathwayWalker, Union{Number, JuMP.AbstractJuMPScalar}}","page":"Defining sequences","title":"MRIBuilder.Pathways.update_walker_gradient!","text":"update_walker_gradient!(gradient_block::GradientWaveform, walker::PathwayWalker, gradient_start_time::VariableType; overlapping_pulses=[], overlapping_readouts=[])\n\nUpdate the walker's qvec and bmat based on the given gradient_block.\n\nThe following steps will be taken:\n\nDo nothing if walker.is_transverse is false\nincrease the appropriate walker.bmat by the outer product of walker.qvec with itself multiplied by the time since the last gradient\nupdate the appropriate walker.qvec and walker.bmat based on the gradient waveform. This will require appropriate qvec/bmat functions to be defined for the gradient building block.\nupdate walker.last_gradient_time to the time at the end of the gradient.\n\nThis requires variables.bmat_gradient and variables.qvec to be implemented for the GradientWaveform.\n\n\n\n\n\n","category":"method"},{"location":"defining_sequence/#MRIBuilder.Pathways.update_walker_instant_gradient!-Union{Tuple{N}, Tuple{InstantGradient{N}, MRIBuilder.Pathways.PathwayWalker, Union{Number, JuMP.AbstractJuMPScalar}}} where N","page":"Defining sequences","title":"MRIBuilder.Pathways.update_walker_instant_gradient!","text":"update_walker_instant_gradient!(gradient, walker)\n\n\n\n\n\n","category":"method"},{"location":"defining_sequence/#MRIBuilder.Pathways.update_walker_pulse!-Tuple{MRIBuilder.Pathways.PathwayWalker, AbstractVector{Symbol}, Union{Number, JuMP.AbstractJuMPScalar}}","page":"Defining sequences","title":"MRIBuilder.Pathways.update_walker_pulse!","text":"update_walker_pulse!(walker::PathwayWalker, pulse_effects::Vector, pulse_time)\n\nApply the first element of pulse_effects to the walker at the given pulse_time.\n\nThe following steps will be taken if the first pulse_effect is not :ignore\n\nif walker.is_transverse is true before the pulse, increase the walker.bmat by the outer product of walker.qvec with itself multiplied by the time since the last gradient\nupdate walker.duration_states with time since last pulse.\nupdate walker.last_pulse_time\nupdate walker.is_transverse, and walker.is_positive based on the first value in pulse_effects. \nif walker.is_positive changed in the previous step than the walker.qvec needs to be flipped.\nremove the first element from pulse_effects.\n\nIf the first element is :ignore the only effect is that the first element is removed from pulse_effects.\n\n\n\n\n\n","category":"method"},{"location":"defining_sequence/#MRIBuilder.Pathways.update_walker_till_time!","page":"Defining sequences","title":"MRIBuilder.Pathways.update_walker_till_time!","text":"update_walker_till_time!(walker::PathwayWalker, new_time[, gradient_group])\n\nUpdates all parts of a PathwayWalker up to the given time.\n\nThis updates the walker.duration_states and the bmat for each gradient tracker. If gradient_group are provided, then only the gradient tracker matching that group will be updated. If that gradient tracker does not exist, it will be created.\n\nThis function is used to get the walker up to date till the start of a gradient, pulse, or final readout.\n\n\n\n\n\n","category":"function"},{"location":"defining_sequence/#MRIBuilder.Pathways.walk_pathway!-Tuple{Sequence, MRIBuilder.Pathways.PathwayWalker, Vector{Symbol}, Ref{Int64}}","page":"Defining sequences","title":"MRIBuilder.Pathways.walk_pathway!","text":"walk_pathway!(bb::Sequence/BuildingBlock, walker::PathwayWalker, pulse_effects::Vector, nreadout::Ref{Int}, start_time)\n\nComputes the effect of a specific ContainerBlock (starting at start_time) on the PathwayWalker.\n\nFor individual pulses and gradients, the following behaviour is implemented:\n\nIf a pulse is encountered, call update_walker_pulse!(walker, pulse_effects, pulse_effective_time)\nIf a gradient is encountered, call update_walker_gradient!(gradient, walker, gradientstarttime)\n\nFor overlapping gradients/pulses, one should first encounter the part of the gradient before the variables.effective_time of the pulse, then apply the pulse, and then the rest of the gradient. This effective time can be passed on to update_walker_gradient! to allow part of the gradient waveform to be applied.\n\nThe function should return true if the Pathway has reached its end (i.e., the final readout) and false otherwise.\n\n\n\n\n\n","category":"method"},{"location":"defining_sequence/#MRIBuilder.Variables.get_pathway","page":"Defining sequences","title":"MRIBuilder.Variables.get_pathway","text":"get_pathway(sequence)\n\nGets the main Pathway that spins are expected to experience in the sequence.\n\nMultiple pathways might be returned as an array or (named)tuple.\n\n\n\n\n\n","category":"function"},{"location":"defining_sequence/#MRIBuilder.Variables.variables.area_under_curve","page":"Defining sequences","title":"MRIBuilder.Variables.variables.area_under_curve","text":"area_under_curve(pathway::Pathway)\n\nReturn net displacement in k-space (i.e., spoiling) experienced by the spins following a specific Pathway.\n\nOnly gradients active while the spins are in the transverse plane are considered.\n\nReturns a NamedTuple with the area_under_curve for all gradient groups.\n\n\n\n\n\n","category":"function"},{"location":"defining_sequence/#MRIBuilder.Variables.variables.bmat","page":"Defining sequences","title":"MRIBuilder.Variables.variables.bmat","text":"bmat(pathway::Pathway)\n\nReturn 3x3 diffusion-weighted matrix experienced by the spins following a specific Pathway in rad^2 ms/um^2.\n\nOnly gradients active while the spins are in the transverse plane are considered.\n\nReturns a NamedTuple with the bmat for all gradient groups.\n\n\n\n\n\n","category":"function"},{"location":"defining_sequence/#MRIBuilder.Variables.variables.bval","page":"Defining sequences","title":"MRIBuilder.Variables.variables.bval","text":"bval(pathway::Pathway)\n\nReturn size of diffusion-weighting experienced by the spins following a specific Pathway in rad^2 ms/um^2.\n\nOnly gradients active while the spins are in the transverse plane will contribute to the diffusion weighting.\n\nReturns a NamedTuple with the bval for all gradient groups.\n\n\n\n\n\n","category":"function"},{"location":"defining_sequence/#MRIBuilder.Variables.variables.duration_dephase","page":"Defining sequences","title":"MRIBuilder.Variables.variables.duration_dephase","text":"duration_dephase(pathway::Pathway)\n\nReturns the net time that spins following the given Pathway spent in the +transverse versus the -transverse state. This determines the amount of T2'-weighting as e^tT_2, where t is the duration_dephase.\n\nAlso see variables.duration_transverse for T2-weighting.\n\n\n\n\n\n","category":"function"},{"location":"defining_sequence/#MRIBuilder.Variables.variables.duration_state","page":"Defining sequences","title":"MRIBuilder.Variables.variables.duration_state","text":"duration_state(pathway::Pathway, transverse::Bool, positive::Bool)\n\nReturns how long the Pathway spent in a specific state.\n\nThe requested state can be set using transverse and positive as follows:\n\ntransverse=false, positive=true: +longitudinal\ntransverse=true, positive=true: +transverse\ntransverse=false, positive=false: -longitudinal\ntransverse=true, positive=false: -transverse\n\n\n\n\n\n","category":"function"},{"location":"defining_sequence/#MRIBuilder.Variables.variables.duration_transverse","page":"Defining sequences","title":"MRIBuilder.Variables.variables.duration_transverse","text":"duration_transverse(pathway::Pathway)\n\nReturns the total amount of time that spins following the given Pathway spent in the transverse plane. This determines the amount of T2-weighting as e^tT_2, where t is the duration_transverse.\n\nAlso see variables.duration_dephase for T2'-weighting.\n\n\n\n\n\n","category":"function"},{"location":"defining_sequence/#MRIBuilder.Variables.variables.net_dephasing","page":"Defining sequences","title":"MRIBuilder.Variables.variables.net_dephasing","text":"net_dephasing(pathway::Pathway)\n\nReturn net displacement vector in k-space/q-space experienced by the spins following a specific Pathway in kHz/um.\n\nOnly gradients active while the spins are in the transverse plane are considered.\n\nReturns a NamedTuple with the qvec for all gradient groups.\n\n\n\n\n\n","category":"function"},{"location":"sequence_optimisation/#sequence_optimisation","page":"Optimisation","title":"Sequence optimisation","text":"","category":"section"},{"location":"sequence_optimisation/","page":"Optimisation","title":"Optimisation","text":"In MRIBuilder an MR Sequence is defined as a sequence of BuildingBlock objects. Most BuildingBlock objects will contain free parameters determining, for example, the duration of the block or the strength/orientation of the MR gradient. In most MR sequence building software, the user will have to set all of these free parameters by computing the appropriate values given a desired echo time, b-value, etc.","category":"page"},{"location":"sequence_optimisation/","page":"Optimisation","title":"Optimisation","text":"In MRIBuilder the internal free parameters are not set directly.  Instead, they are inferred using a non-linear, constrained optimisation. For each sequence type, the developer defines how to compute various summary variables from the BuildingBlock free parameters, such as variables.echo_time, variables.duration, variables.resolution, variables.gradient_strength, variables.diffusion_time, variables.duration_transverse etc. A user can then create a specific instantiation of the sequence by fixing any of these summary variables to their desired values (or setting them to :min/:max to minimise/maximise them). In addition to the user-defined constraints, this optimisation will also take into account any scanner-defined constraints. Internally, MRIBuilder will then optimise the BuildingBlock free parameters to match any user-defined constraints and/or objectives. This optimisation uses the Ipopt optimiser accessed through the JuMP.jl library.","category":"page"},{"location":"sequence_optimisation/","page":"Optimisation","title":"Optimisation","text":"In addition to any user-defined objectives, the developer might also have defined secondary objectives (e.g., minimise the total sequence duration).  These objective functions will only be considered if they do not affect the result of the user-defined primary objective. More details on these developer-defined secondary objectives can be found in the section on defining new sequences","category":"page"},{"location":"sequence_optimisation/#variables","page":"Optimisation","title":"Summary variables","text":"","category":"section"},{"location":"sequence_optimisation/","page":"Optimisation","title":"Optimisation","text":"All variables are available as members of the variables structure.","category":"page"},{"location":"sequence_optimisation/","page":"Optimisation","title":"Optimisation","text":"CollapsedDocStrings = true","category":"page"},{"location":"sequence_optimisation/","page":"Optimisation","title":"Optimisation","text":"variables","category":"page"},{"location":"sequence_optimisation/#MRIBuilder.Variables.variables","page":"Optimisation","title":"MRIBuilder.Variables.variables","text":"Main module containing all the MRIBuilder sequence variables.\n\nAll variables are available as members of this module, e.g. variables.echo_time returns the echo time variable. New variables can be defined using @defvar.\n\nSet constraints on variables by passing them on as keywords during the sequence generation, e.g., seq=SpinEcho(echo_time=70).\n\nAfter sequence generation you can get the variable values by calling variables.echo_time(seq). For the sequence defined above this would return 70. (or a number very close to that).\n\n\n\n\n\n","category":"module"},{"location":"sequence_optimisation/","page":"Optimisation","title":"Optimisation","text":"variables.N_left                    \nvariables.N_right                   \nvariables.TE                        \nvariables.TR                        \nvariables.all_gradient_strengths\nvariables.amplitude                 \nvariables.area_under_curve          \nvariables.bandwidth                 \nvariables.bmat                      \nvariables.bmat_gradient\nvariables.bval                      \nvariables.delay                     \nvariables.diffusion_time            \nvariables.duration                  \nvariables.duration_dephase\nvariables.duration_state            \nvariables.duration_transverse       \nvariables.dwell_time\nvariables.echo_time                 \nvariables.effective_time            \nvariables.flat_time                 \nvariables.flip_angle\nvariables.fov                       \nvariables.frequency                 \nvariables.gradient_strength         \nvariables.gradient_strength_norm    \nvariables.lobe_duration             \nvariables.net_dephasing             \nvariables.nsamples\nvariables.oversample                \nvariables.phase                     \nvariables.qval                      \nvariables.qvec\nvariables.ramp_overlap              \nvariables.readout_times             \nvariables.resolution                \nvariables.rise_time                 \nvariables.slew_rate\nvariables.slew_rate_norm            \nvariables.slice_thickness           \nvariables.spoiler\nvariables.time_to_center            \nvariables.voxel_size                \nvariables.Δ                         \nvariables.δ","category":"page"},{"location":"sequence_optimisation/#MRIBuilder.Variables.variables.N_left-sequence_optimisation","page":"Optimisation","title":"MRIBuilder.Variables.variables.N_left","text":"N_left(sinc_pulse)\n\nNumber of zero-crossings of the SincPulse before the maximum.\n\nAlso, see variables.N_right\n\n\n\n\n\n","category":"function"},{"location":"sequence_optimisation/#MRIBuilder.Variables.variables.N_right-sequence_optimisation","page":"Optimisation","title":"MRIBuilder.Variables.variables.N_right","text":"N_left(sinc_pulse)\n\nNumber of zero-crossings of the SincPulse after the maximum.\n\nAlso, see variables.N_left\n\n\n\n\n\n","category":"function"},{"location":"sequence_optimisation/#MRIBuilder.Variables.variables.TE-sequence_optimisation","page":"Optimisation","title":"MRIBuilder.Variables.variables.TE","text":"echo_time(sequence)\n\nReturns the echo time of a sequence in ms.\n\nThis is typically defined as the time between the excitation pulse and the crossing of k=0 during the MRI readout.\n\n\n\n\n\necho_time(sequence)\n\nComputes the echo time(s) of a sequence in ms.\n\n\n\n\n\n","category":"function"},{"location":"sequence_optimisation/#MRIBuilder.Variables.variables.TR-sequence_optimisation","page":"Optimisation","title":"MRIBuilder.Variables.variables.TR","text":"repetition_time(sequence)\n\nComputes the repetition_times of a sequence in ms.\n\n\n\n\n\n","category":"function"},{"location":"sequence_optimisation/#MRIBuilder.Variables.variables.all_gradient_strengths-sequence_optimisation","page":"Optimisation","title":"MRIBuilder.Variables.variables.all_gradient_strengths","text":"all_gradient_strengths(spoilt_slice_select)\n\nReturns the gradient strength before, during, and after the pulse in SpoiltSliceSelect.\n\n\n\n\n\n","category":"function"},{"location":"sequence_optimisation/#MRIBuilder.Variables.variables.amplitude-sequence_optimisation","page":"Optimisation","title":"MRIBuilder.Variables.variables.amplitude","text":"amplitude(pulse)\n\nReturn the amplitude of an RFPulseComponent in kHz.\n\n\n\n\n\n","category":"function"},{"location":"sequence_optimisation/#MRIBuilder.Variables.variables.area_under_curve-sequence_optimisation","page":"Optimisation","title":"MRIBuilder.Variables.variables.area_under_curve","text":"area_under_curve(pathway::Pathway)\n\nReturn net displacement in k-space (i.e., spoiling) experienced by the spins following a specific Pathway.\n\nOnly gradients active while the spins are in the transverse plane are considered.\n\nReturns a NamedTuple with the area_under_curve for all gradient groups.\n\n\n\n\n\n","category":"function"},{"location":"sequence_optimisation/#MRIBuilder.Variables.variables.bandwidth-sequence_optimisation","page":"Optimisation","title":"MRIBuilder.Variables.variables.bandwidth","text":"bandwidth(pulse)\n\nReturn the bandwidth of an RFPulseComponent in kHz.\n\n\n\n\n\n","category":"function"},{"location":"sequence_optimisation/#MRIBuilder.Variables.variables.bmat-sequence_optimisation","page":"Optimisation","title":"MRIBuilder.Variables.variables.bmat","text":"bmat(pathway::Pathway)\n\nReturn 3x3 diffusion-weighted matrix experienced by the spins following a specific Pathway in rad^2 ms/um^2.\n\nOnly gradients active while the spins are in the transverse plane are considered.\n\nReturns a NamedTuple with the bmat for all gradient groups.\n\n\n\n\n\n","category":"function"},{"location":"sequence_optimisation/#MRIBuilder.Variables.variables.bmat_gradient-sequence_optimisation","page":"Optimisation","title":"MRIBuilder.Variables.variables.bmat_gradient","text":"bmat_gradient(overlapping, qstart[, first_event, last_event])\n\nComputes the addition to the variables.bmat contributed by a specific building block or gradient.\n\nqstart represents the variables.qvec at the start of this component.\n\nIf first_event is set to something else than nothing, only the gradient waveform after this RF pulse/Readout will be considered. Similarly, if last_event is set to something else than nothing, only the gradient waveform up to this RF pulse/Readout will be considered.\n\n\n\n\n\n","category":"function"},{"location":"sequence_optimisation/#MRIBuilder.Variables.variables.bval-sequence_optimisation","page":"Optimisation","title":"MRIBuilder.Variables.variables.bval","text":"bval(pathway::Pathway)\n\nReturn size of diffusion-weighting experienced by the spins following a specific Pathway in rad^2 ms/um^2.\n\nOnly gradients active while the spins are in the transverse plane will contribute to the diffusion weighting.\n\nReturns a NamedTuple with the bval for all gradient groups.\n\n\n\n\n\n","category":"function"},{"location":"sequence_optimisation/#MRIBuilder.Variables.variables.delay-sequence_optimisation","page":"Optimisation","title":"MRIBuilder.Variables.variables.delay","text":"delay(sequence)\n\nReturns the offset beetween the readout and the spin echo in ms.\n\n\n\n\n\n","category":"function"},{"location":"sequence_optimisation/#MRIBuilder.Variables.variables.diffusion_time-sequence_optimisation","page":"Optimisation","title":"MRIBuilder.Variables.variables.diffusion_time","text":"diffusion_time(diffusion_sequence)\n\nReturns the diffusion time of a DiffusionSpinEcho in ms.\n\n\n\n\n\ndiffusion_time(sequence)\n\nComputes the diffusion time of a sequence in ms.\n\n\n\n\n\n","category":"function"},{"location":"sequence_optimisation/#MRIBuilder.Variables.variables.duration-sequence_optimisation","page":"Optimisation","title":"MRIBuilder.Variables.variables.duration","text":"duration(block)\n\nDuration of the sequence or building block in ms.\n\n\n\n\n\n","category":"function"},{"location":"sequence_optimisation/#MRIBuilder.Variables.variables.duration_dephase-sequence_optimisation","page":"Optimisation","title":"MRIBuilder.Variables.variables.duration_dephase","text":"duration_dephase(pathway::Pathway)\n\nReturns the net time that spins following the given Pathway spent in the +transverse versus the -transverse state. This determines the amount of T2'-weighting as e^tT_2, where t is the duration_dephase.\n\nAlso see variables.duration_transverse for T2-weighting.\n\n\n\n\n\n","category":"function"},{"location":"sequence_optimisation/#MRIBuilder.Variables.variables.duration_state-sequence_optimisation","page":"Optimisation","title":"MRIBuilder.Variables.variables.duration_state","text":"duration_state(pathway::Pathway, transverse::Bool, positive::Bool)\n\nReturns how long the Pathway spent in a specific state.\n\nThe requested state can be set using transverse and positive as follows:\n\ntransverse=false, positive=true: +longitudinal\ntransverse=true, positive=true: +transverse\ntransverse=false, positive=false: -longitudinal\ntransverse=true, positive=false: -transverse\n\n\n\n\n\n","category":"function"},{"location":"sequence_optimisation/#MRIBuilder.Variables.variables.duration_transverse-sequence_optimisation","page":"Optimisation","title":"MRIBuilder.Variables.variables.duration_transverse","text":"duration_transverse(pathway::Pathway)\n\nReturns the total amount of time that spins following the given Pathway spent in the transverse plane. This determines the amount of T2-weighting as e^tT_2, where t is the duration_transverse.\n\nAlso see variables.duration_dephase for T2'-weighting.\n\n\n\n\n\n","category":"function"},{"location":"sequence_optimisation/#MRIBuilder.Variables.variables.dwell_time-sequence_optimisation","page":"Optimisation","title":"MRIBuilder.Variables.variables.dwell_time","text":"dwell_time(adc)\n\nThe dwell time of the ADC readout in ms.\n\n\n\n\n\n","category":"function"},{"location":"sequence_optimisation/#MRIBuilder.Variables.variables.echo_time-sequence_optimisation","page":"Optimisation","title":"MRIBuilder.Variables.variables.echo_time","text":"echo_time(sequence)\n\nReturns the echo time of a sequence in ms.\n\nThis is typically defined as the time between the excitation pulse and the crossing of k=0 during the MRI readout.\n\n\n\n\n\necho_time(sequence)\n\nComputes the echo time(s) of a sequence in ms.\n\n\n\n\n\n","category":"function"},{"location":"sequence_optimisation/#MRIBuilder.Variables.variables.effective_time-sequence_optimisation","page":"Optimisation","title":"MRIBuilder.Variables.variables.effective_time","text":"effective_time(container, indices...)\n\nReturns the start time of component with given indices with respect to the start of the ContainerBlock.\n\nThis will crash if the component does not have an variables.effective_time (e.g., if it is (part of) a gradient waveform).\n\nAlso see variables.duration, start_time, and end_time\n\n\n\n\n\n","category":"function"},{"location":"sequence_optimisation/#MRIBuilder.Variables.variables.flat_time-sequence_optimisation","page":"Optimisation","title":"MRIBuilder.Variables.variables.flat_time","text":"flat_time(trapezoid)\n\nReturns the flat time of a Trapezoid gradient profile in ms.\n\n\n\n\n\n","category":"function"},{"location":"sequence_optimisation/#MRIBuilder.Variables.variables.flip_angle-sequence_optimisation","page":"Optimisation","title":"MRIBuilder.Variables.variables.flip_angle","text":"flip_angle(pulse)\n\nReturn the flip angle of an RFPulseComponent in degrees.\n\n\n\n\n\n","category":"function"},{"location":"sequence_optimisation/#MRIBuilder.Variables.variables.fov-sequence_optimisation","page":"Optimisation","title":"MRIBuilder.Variables.variables.fov","text":"fov(readout)\n\nDefines the field of view of a readout in mm.\n\n\n\n\n\n","category":"function"},{"location":"sequence_optimisation/#MRIBuilder.Variables.variables.frequency-sequence_optimisation","page":"Optimisation","title":"MRIBuilder.Variables.variables.frequency","text":"frequency(pulse)\n\nReturn the off-resonance frequency of an RFPulseComponent in kHz.\n\n\n\n\n\n","category":"function"},{"location":"sequence_optimisation/#MRIBuilder.Variables.variables.gradient_strength-sequence_optimisation","page":"Optimisation","title":"MRIBuilder.Variables.variables.gradient_strength","text":"gradient_strength(gradient)\n\nMaximum 3D gradient strength of the gradient in kHz/um.\n\n\n\n\n\n","category":"function"},{"location":"sequence_optimisation/#MRIBuilder.Variables.variables.gradient_strength_norm-sequence_optimisation","page":"Optimisation","title":"MRIBuilder.Variables.variables.gradient_strength_norm","text":"gradient_strength_norm(gradient)\n\nThe norm of the variables.gradient_strength.\n\n\n\n\n\n","category":"function"},{"location":"sequence_optimisation/#MRIBuilder.Variables.variables.lobe_duration-sequence_optimisation","page":"Optimisation","title":"MRIBuilder.Variables.variables.lobe_duration","text":"lobe_duration(sinc_pulse)\n\nTime between two zero-crossings of a SincPulse.\n\n\n\n\n\n","category":"function"},{"location":"sequence_optimisation/#MRIBuilder.Variables.variables.net_dephasing-sequence_optimisation","page":"Optimisation","title":"MRIBuilder.Variables.variables.net_dephasing","text":"net_dephasing(pathway::Pathway)\n\nReturn net displacement vector in k-space/q-space experienced by the spins following a specific Pathway in kHz/um.\n\nOnly gradients active while the spins are in the transverse plane are considered.\n\nReturns a NamedTuple with the qvec for all gradient groups.\n\n\n\n\n\n","category":"function"},{"location":"sequence_optimisation/#MRIBuilder.Variables.variables.nsamples-sequence_optimisation","page":"Optimisation","title":"MRIBuilder.Variables.variables.nsamples","text":"nsamples(adc)\n\nNumber of samples in an ADC.\n\n\n\n\n\n","category":"function"},{"location":"sequence_optimisation/#MRIBuilder.Variables.variables.oversample-sequence_optimisation","page":"Optimisation","title":"MRIBuilder.Variables.variables.oversample","text":"oversample(adc)\n\nThe oversampling rate of the ADC readout.\n\n\n\n\n\n","category":"function"},{"location":"sequence_optimisation/#MRIBuilder.Variables.variables.phase-sequence_optimisation","page":"Optimisation","title":"MRIBuilder.Variables.variables.phase","text":"phase(pulse)\n\nReturn the phase of an RFPulseComponent in degrees.\n\n\n\n\n\n","category":"function"},{"location":"sequence_optimisation/#MRIBuilder.Variables.variables.qval-sequence_optimisation","page":"Optimisation","title":"MRIBuilder.Variables.variables.qval","text":"qval(gradient)\n\nThe norm of the variables.qvec.\n\n\n\n\n\n","category":"function"},{"location":"sequence_optimisation/#MRIBuilder.Variables.variables.qvec-sequence_optimisation","page":"Optimisation","title":"MRIBuilder.Variables.variables.qvec","text":"qvec(overlapping[, first_event, last_event])\n\nComputes the area under the curve for the gradient waveform in BaseBuildingBlock.\n\nIf first_event is set to something else than nothing, only the gradient waveform after this RF pulse/Readout will be considered. Similarly, if last_event is set to something else than nothing, only the gradient waveform up to this RF pulse/Readout will be considered.\n\n\n\n\n\nqvec(gradient)\n\nThe total integral of the area under the gradient curve as a length-3 vector.\n\nThe norm of this vector is available as qval.\n\n\n\n\n\n","category":"function"},{"location":"sequence_optimisation/#MRIBuilder.Variables.variables.ramp_overlap-sequence_optimisation","page":"Optimisation","title":"MRIBuilder.Variables.variables.ramp_overlap","text":"ramp_overlap(line_readout)\n\nReturn the fraction of the gradient ramp that overlaps with the ADC readout.\n\nSet to 0 to ensure that the ADC is only active during the flat time of the readout.\n\n\n\n\n\n","category":"function"},{"location":"sequence_optimisation/#MRIBuilder.Variables.variables.readout_times-sequence_optimisation","page":"Optimisation","title":"MRIBuilder.Variables.variables.readout_times","text":"readout_times(sequence)\n\nReturns all the times that the sequence will readout.\n\n\n\n\n\n","category":"function"},{"location":"sequence_optimisation/#MRIBuilder.Variables.variables.resolution-sequence_optimisation","page":"Optimisation","title":"MRIBuilder.Variables.variables.resolution","text":"resolution(readout)\n\nResolution of the readout.\n\n\n\n\n\n","category":"function"},{"location":"sequence_optimisation/#MRIBuilder.Variables.variables.rise_time-sequence_optimisation","page":"Optimisation","title":"MRIBuilder.Variables.variables.rise_time","text":"rise_time(trapezoid)\n\nReturns the rise time of a Trapezoid gradient profile in ms.\n\n\n\n\n\n","category":"function"},{"location":"sequence_optimisation/#MRIBuilder.Variables.variables.slew_rate-sequence_optimisation","page":"Optimisation","title":"MRIBuilder.Variables.variables.slew_rate","text":"slew_rate(gradient)\n\nMaximum 3D slew rate of the gradient in kHz/um/ms.\n\n\n\n\n\n","category":"function"},{"location":"sequence_optimisation/#MRIBuilder.Variables.variables.slew_rate_norm-sequence_optimisation","page":"Optimisation","title":"MRIBuilder.Variables.variables.slew_rate_norm","text":"slew_rate_norm(gradient)\n\nThe norm of the variables.slew_rate.\n\n\n\n\n\n","category":"function"},{"location":"sequence_optimisation/#MRIBuilder.Variables.variables.slice_thickness-sequence_optimisation","page":"Optimisation","title":"MRIBuilder.Variables.variables.slice_thickness","text":"slice_thickness(slice_select)\n\nDefines the slice thickness for a RF pulse with an active gradient in mm (e.g., SliceSelect).\n\nDefines as variables.gradient_strength_norm(gradient) / variables.bandwidth(pulse)\n\n\n\n\n\n","category":"function"},{"location":"sequence_optimisation/#MRIBuilder.Variables.variables.spoiler-sequence_optimisation","page":"Optimisation","title":"MRIBuilder.Variables.variables.spoiler","text":"spoiler(gradient)\n\nSpatial scale in mm over which the spoiler gradient will dephase by 2π.\n\nAutomatically computed based on variables.qvec.\n\n\n\n\n\n","category":"function"},{"location":"sequence_optimisation/#MRIBuilder.Variables.variables.time_to_center-sequence_optimisation","page":"Optimisation","title":"MRIBuilder.Variables.variables.time_to_center","text":"time_to_center(adc)\n\nThe time of the ADC readout to reach the center of k-space.\n\n\n\n\n\n","category":"function"},{"location":"sequence_optimisation/#MRIBuilder.Variables.variables.voxel_size-sequence_optimisation","page":"Optimisation","title":"MRIBuilder.Variables.variables.voxel_size","text":"voxel_size(readout)\n\nDefines the voxel size of a readout in mm.\n\n\n\n\n\n","category":"function"},{"location":"sequence_optimisation/#MRIBuilder.Variables.variables.Δ-sequence_optimisation","page":"Optimisation","title":"MRIBuilder.Variables.variables.Δ","text":"diffusion_time(diffusion_sequence)\n\nReturns the diffusion time of a DiffusionSpinEcho in ms.\n\n\n\n\n\ndiffusion_time(sequence)\n\nComputes the diffusion time of a sequence in ms.\n\n\n\n\n\n","category":"function"},{"location":"sequence_optimisation/#MRIBuilder.Variables.variables.δ-sequence_optimisation","page":"Optimisation","title":"MRIBuilder.Variables.variables.δ","text":"δ(trapezoid)\n\nReturns the effective duration of a Trapezoid gradient profile in ms.\n\nDefined as variables.rise_time + variables.flat_time.\n\n\n\n\n\n","category":"function"},{"location":"sequence_optimisation/#Variables-interface","page":"Optimisation","title":"Variables interface","text":"","category":"section"},{"location":"sequence_optimisation/","page":"Optimisation","title":"Optimisation","text":"Modules = [\n    MRIBuilder.Variables,\n]","category":"page"},{"location":"sequence_optimisation/#MRIBuilder.Variables","page":"Optimisation","title":"MRIBuilder.Variables","text":"Defines the functions that can be called on parts of an MRI sequence to query or constrain any variables.\n\nIn addition this defines:\n\nvariables: module containing all variables.\nVariableType: parent type for any variables (whether number or JuMP variable).\nget_free_variable: helper function to create new JuMP variables.\nadd_cost_function!: add a specific term to the model cost functions.\nset_simple_constraints!: call apply_simple_constraint! for each keyword argument.\napply_simple_constraint!: set a simple equality constraint.\nget_pulse/get_gradient/get_readout: Used to get the pulse/gradient/readout part of a building block\ngradient_orientation: returns the gradient orientation of a waveform if fixed.\n\n\n\n\n\n","category":"module"},{"location":"sequence_optimisation/#MRIBuilder.Variables.VariableType","page":"Optimisation","title":"MRIBuilder.Variables.VariableType","text":"Parent type for any variable in the MRI sequence.\n\nEach variable can be one of:\n\na new JuMP variable\nan expression linking this variable to other JuMP variable\na number\n\nCreate these using get_free_variable.\n\n\n\n\n\n","category":"type"},{"location":"sequence_optimisation/#MRIBuilder.Variables.alternative_variables","page":"Optimisation","title":"MRIBuilder.Variables.alternative_variables","text":"Mapping of variable names to alternative ways to compute that variables.\n\n\n\n\n\n","category":"constant"},{"location":"sequence_optimisation/#MRIBuilder.Variables.default_generic_method","page":"Optimisation","title":"MRIBuilder.Variables.default_generic_method","text":"Contains for each variable the default, generic method.\n\nThis is the method that checks for alternative_functions or uses one of the getters.\n\n\n\n\n\n","category":"constant"},{"location":"sequence_optimisation/#MRIBuilder.Variables.getter_functions","page":"Optimisation","title":"MRIBuilder.Variables.getter_functions","text":"Mapping of symbols to actual getter functions.\n\nUsed in set_getter!.\n\n\n\n\n\n","category":"constant"},{"location":"sequence_optimisation/#MRIBuilder.Variables.getters","page":"Optimisation","title":"MRIBuilder.Variables.getters","text":"Assigns getters to specific variables.\n\n\n\n\n\n","category":"constant"},{"location":"sequence_optimisation/#MRIBuilder.Variables.AbstractBlock","page":"Optimisation","title":"MRIBuilder.Variables.AbstractBlock","text":"Parent type of all components, building block, and sequences that form an MRI sequence.\n\n\n\n\n\n","category":"type"},{"location":"sequence_optimisation/#MRIBuilder.Variables.InvalidRoute","page":"Optimisation","title":"MRIBuilder.Variables.InvalidRoute","text":"Raised if there is no way to reach a valid function by the default, generic method (default_generic_method).\n\n\n\n\n\n","category":"type"},{"location":"sequence_optimisation/#MRIBuilder.Variables._get_mult_variable-Tuple{Any, Any, Vararg{Any}}","page":"Optimisation","title":"MRIBuilder.Variables._get_mult_variable","text":"Helper to call the variable for a result of a getter. Used in _get_variable.\n\n\n\n\n\n","category":"method"},{"location":"sequence_optimisation/#MRIBuilder.Variables._get_variable-Tuple{Symbol, Set{Symbol}, Vararg{Any}}","page":"Optimisation","title":"MRIBuilder.Variables._get_variable","text":"_get_variable(name, tried_names, args...; kwargs...)\n\nTries to find a route to get values for the variable name with the given args and kwargs.\n\nThe route through tried_names has already been attempted.\n\nThis function returns the route to get to the value and the value itself.\n\n\n\n\n\n","category":"method"},{"location":"sequence_optimisation/#MRIBuilder.Variables.add_alternative_variable!-Tuple{Symbol, Symbol, Function, Bool}","page":"Optimisation","title":"MRIBuilder.Variables.add_alternative_variable!","text":"add_alternative_variable!(name, other_func, conversion)\n\nDefines an alternative way to compute the variable with given name.\n\nIf the variable name is not defined and other_name is, then the value of name is computed by applying conversion to the value of other_name.\n\n\n\n\n\n","category":"method"},{"location":"sequence_optimisation/#MRIBuilder.Variables.add_cost_function!","page":"Optimisation","title":"MRIBuilder.Variables.add_cost_function!","text":"add_cost_function!(function, level=2)\n\nAdds an additional term to the cost function.\n\nThis term will be minimised together with any other terms in the cost function. Terms added at a lower level will be optimised before any terms with a higher level.\n\nBy default, the term is added to the level=2, which is appropriate for any cost functions added by the developer, which will generally only be optimised after any user-defined cost functions (which are added at level=1 by add_simple_constraint! or set_simple_constraints!.\n\nAny sequence will also have a level=3 cost function, which minimises the total sequence duration.\n\n\n\n\n\n","category":"function"},{"location":"sequence_optimisation/#MRIBuilder.Variables.add_new_variable!-Tuple{Symbol}","page":"Optimisation","title":"MRIBuilder.Variables.add_new_variable!","text":"add_new_variable!(name)\n\nAdds a new variable in variables.\n\nThis is a helper function, which is called by @defvar for any variable that does not exist yet.\n\n\n\n\n\n","category":"method"},{"location":"sequence_optimisation/#MRIBuilder.Variables.adjust_groups-Tuple{MRIBuilder.Variables.AbstractBlock}","page":"Optimisation","title":"MRIBuilder.Variables.adjust_groups","text":"adjust_groups(block)\n\nReturns an array of keywords in adjust that should affect a specfic block.\n\nIf any of these keywords are present in adjust, then adjust_internal will be called.\n\nSome standard keywords are:\n\n:gradient: expects gradient adjustment parameters\n:pulse: expects RF pulse adjustment parameters\n\n\n\n\n\n","category":"method"},{"location":"sequence_optimisation/#MRIBuilder.Variables.adjust_internal","page":"Optimisation","title":"MRIBuilder.Variables.adjust_internal","text":"adjust_internal(block, names_used; kwargs...)\n\nReturns the adjusted blocks and add any keywords used in the process to names_used.\n\nThis is a helper function used by adjust.  It should be defined for any block that is adjustable (as defined by adjust_groups).\n\n\n\n\n\n","category":"function"},{"location":"sequence_optimisation/#MRIBuilder.Variables.apply_simple_constraint!-Tuple{AbstractVector, Symbol}","page":"Optimisation","title":"MRIBuilder.Variables.apply_simple_constraint!","text":"apply_simple_constraint!(variable, value)\n\nAdd a single constraint or objective to the variable.\n\nvalue can be one of:\n\nnothing: do nothing\n:min: minimise the variable\n:max: maximise the variable\nnumber: fix variable to this value\nequation: fix variable to the result of this equation\n\napply_simple_constraint!(variable, :>=/:<=, value)\n\nSet an inequality constraint to the variable.\n\nvalue can be a number of an equation.\n\n\n\n\n\n","category":"method"},{"location":"sequence_optimisation/#MRIBuilder.Variables.base_variables-Tuple{}","page":"Optimisation","title":"MRIBuilder.Variables.base_variables","text":"base_variables([T])\n\nReturn dictionary with all Variable objects defined for a specific sequence component/block T.\n\nThis only returns those Variable directly defined for this component/block, not for any sub-components (through get_pulse, [get_gradient][(@ref), etc.)\n\nIf T is not provided, all Variable objects are returned.\n\n\n\n\n\n","category":"method"},{"location":"sequence_optimisation/#MRIBuilder.Variables.get_free_variable-Tuple{Number}","page":"Optimisation","title":"MRIBuilder.Variables.get_free_variable","text":"get_free_variable(value; integer=false, start=0.01)\n\nGet a representation of a given variable given a user-defined constraint.\n\nThe result is guaranteed to be a VariableType.\n\n\n\n\n\n","category":"method"},{"location":"sequence_optimisation/#MRIBuilder.Variables.get_readout","page":"Optimisation","title":"MRIBuilder.Variables.get_readout","text":"get_readout(sequence)\n\nGet the main readout events played out during the sequence.\n\nThis has to be defined for individual sequences to work.\n\nAny readout variables not explicitly defined for this sequence will be passed on to the readout.\n\n\n\n\n\n","category":"function"},{"location":"sequence_optimisation/#MRIBuilder.Variables.gradient_orientation","page":"Optimisation","title":"MRIBuilder.Variables.gradient_orientation","text":"gradient_orientation(building_block)\n\nReturns the gradient orientation.\n\n\n\n\n\n","category":"function"},{"location":"sequence_optimisation/#MRIBuilder.Variables.make_generic","page":"Optimisation","title":"MRIBuilder.Variables.make_generic","text":"make_generic(sequence/building_block/component)\n\nReturns a generic version of the BaseSequence, BaseBuildingBlock, or BaseComponent\n\nSequences are all flattened and returned as a single Sequence containing only BuildingBlock objects.\nAny BaseBuildingBlock is converted into a BuildingBlock.\nPulses are replaced with GenericPulse (except for instant pulses).\nInstant readouts are replaced with ADC.\n\n\n\n\n\n","category":"function"},{"location":"sequence_optimisation/#MRIBuilder.Variables.scanner_constraints!-Tuple{MRIBuilder.Variables.AbstractBlock}","page":"Optimisation","title":"MRIBuilder.Variables.scanner_constraints!","text":"scanner_constraints!(block)\n\nConstraints variables.gradient_strength and variables.slew_rate to be less than the global_scanner maximum.\n\n\n\n\n\n","category":"method"},{"location":"sequence_optimisation/#MRIBuilder.Variables.set_getter!-Tuple{Symbol, Symbol}","page":"Optimisation","title":"MRIBuilder.Variables.set_getter!","text":"set_getter!(variable_name, getter)\n\nSet the getter function for variable_name.\n\nIf the value for variable is not defined for a sequence, the value for the result of the getter function is returned instead.\n\nPossible values for the getter function are:\n\n:pulse: get_pulse\n:gradient: get_gradient\n:readout: get_readout\n:pathway: get_pathway\n\n\n\n\n\n","category":"method"},{"location":"sequence_optimisation/#MRIBuilder.Variables.set_simple_constraints!-Tuple{MRIBuilder.Variables.AbstractBlock, Any}","page":"Optimisation","title":"MRIBuilder.Variables.set_simple_constraints!","text":"set_simple_constraints!(block, kwargs)\n\nAdd any constraints or objective functions to the variables of a AbstractBlock.\n\nEach keyword argument has to match one of the functions in variables(block). If set to a numeric value, a constraint will be added to fix the function value to that numeric value. If set to :min or :max, minimising or maximising this function will be added to the cost function.\n\n\n\n\n\n","category":"method"},{"location":"sequence_optimisation/#MRIBuilder.Variables.variable_defined_for-Tuple{Symbol, Vararg{Any}}","page":"Optimisation","title":"MRIBuilder.Variables.variable_defined_for","text":"variable_defined_for(variable, args...; kwargs...)\n\n\n\n\n\n","category":"method"},{"location":"sequence_optimisation/#MRIBuilder.Variables.@defvar-Tuple{Any, Any}","page":"Optimisation","title":"MRIBuilder.Variables.@defvar","text":"@defvar(function(s))\n\nDefines new variables.\n\nEach variable is defined as regular Julia functions embedded within a @defvar macro. For example, to define a variables.echo_time variable for a SpinEcho sequence, one can use:\n\n@defvar echo_time(ge::SpinEcho) = 2 * (variables.effective_time(ge, :refocus) - variables.effective_time(ge, :excitation))\n\nMultiple variables can be defined in a single @defvar by including them in a code block:\n\n@defvar begin\n    function var1(seq::SomeSequenceType)\n        ...\n    end\n    function var2(seq::SomeSequenceType)\n        ...\n    end\nend\n\n\n\n\n\n","category":"macro"},{"location":"#MRIBuilder","page":"Home","title":"MRIBuilder","text":"","category":"section"},{"location":"","page":"Home","title":"Home","text":"MRIBuilder allows for the creation and optimisation of MRI sequences within Julia.","category":"page"},{"location":"","page":"Home","title":"Home","text":"Depending on your application, there are several levels at which you can interact with MRIBuilder. The ones lower down require more expertise with Julia and the internals of MRIBuilder:","category":"page"},{"location":"","page":"Home","title":"Home","text":"Many sequences have already been implemented and can be obtained through a simple function call (see Using implemented sequences).\nNew sequences can be created out of pre-defined sequence components and by defining sequence-specific metrics (see Defining new sequences).\nFinally, one can actually define new sequence components (not documented yet).","category":"page"},{"location":"","page":"Home","title":"Home","text":"Typically, the resulting sequence will only cover a single repetition time (TR). MRIBuilder enables the concatenation of single-TR sequences into a multi-TR sequence. During these repeats minor adjustments can be made to the single-TR sequence. This can be used to allow different repeats to image different lines in k-space or excite different slices (see Post-hoc adjustment of sequences).","category":"page"},{"location":"","page":"Home","title":"Home","text":"The signal formation for the resulting sequence can be predicted using MCMRSimulator given some representation of the imaged tissue. MRIBuilder can be used to read/write to the pulseq MR sequence file format. This can be used to run the sequence on MRI scanners as described in the pulseq homepage. Rather than just directly running the sequences from this library on the scanner, we strongly recommend to load it using the MATLAB pulseq or python pypulseq first as these libraries run additional checks!","category":"page"},{"location":"#Installation","page":"Home","title":"Installation","text":"","category":"section"},{"location":"","page":"Home","title":"Home","text":"It can be run from the command line using the Julia REPL, from a Julia script, or in a Jupyter notebook. Like any Julia package, Julia can be installed using the built-in Julia package manager:","category":"page"},{"location":"","page":"Home","title":"Home","text":"pkg> add https://git.fmrib.ox.ac.uk/ndcn0236/mribuilder.jl.git","category":"page"}]
}
